********************************************************************************

                             --------------------
                             doptomog version 2.0
                             --------------------

     Copyright (C) 2015  Enrico J. Kotze ejk@saao.ac.za

     This program is free software: you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation, either version 3 of the License, or
     (at your option) any later version.

     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.

     You should have received a copy of the GNU General Public License
     along with this program.  If not, see <http://www.gnu.org/licenses/>.

********************************************************************************

The code was written in Fortran 90/95/2003, IDL, Gnuplot and bash on a Linux
operating system with the following configuration:

	- gfortran	4.8.4
	- IDL		7.1
	- Gnuplot	4.6 patchlevel 4
	- bash		4.3.11(1)

This is the minimum configuration needed for the doptomog package to work as
described below.

********************************************************************************

There are 8 bash scripts in the doptomog/ folder, prefixed 0 to 7 for a logical
stepped process to obtain science grade results.
The scripts may be launched from a file browser (choose "Run in Terminal") or a
terminal command line (use "source ***.sh" where *** signifies the script name).
Prompts for the necessary user input are displayed in the terminal.
See below the sections on the input and output data structures for the input
needed and the output produced by steps 1 to 7.

Step 0:

  0-make.clean.sh

  - remove all previously compiled code and/or compile all code in the code
    folder

Step 1:

  1-exec.pspectra.prepare.sh

  - prepare the input spectra to facilitate the extraction of spectral lines

Step 2:

  2-exec.pspectra.extract.sh

  - extract a specified spectral line

Step 3:

  3-exec.pdoptomog.sh

  - perform Doppler tomography using a fast maximum entropy algorithm on an
    extracted spectral line

  - perform consecutive half-phase Doppler tomography for a specified number of
    half phases
    (see input file doptomog.in in the relevant folder described below)

  - perform flux modulation mapping based on the consecutive half-phase Doppler
    tomography

Step 4:

  4-idl.doptomog.pre.sh

  - perform a visualisation (IDL) of the Doppler tomography results

Step 5:

  5-exec.pbinarymodel.sh

  - calculate a model 2d velocity overlay and a model 3d spatial construct

Step 6:

  6-idl.doptomog.sh

  - perform a visualisation (IDL) of the Doppler tomogram without and with the
    model 2d velocity overlay

Step 7:

  7-gnu.binarymodel.sh

  - perform a visualisation (Gnuplot) of the model 3d spatial construct

NOTE: Each script in the stepped process will compile its code if necessary.

********************************************************************************

The code is organised in the following folders:

  code/
  
  - makefile
  
  - Fortran 90/95/2003 code for

    --	pspectra: program to prepare and extract input spectra
    	mspectra: module holding all declared program variables

    --	pbinarymodel: program to calculate a model 2d velocity overlay and a
    	model 3d spatial construct for the source
    	mbinarymodel: module holding all declared program variables

    --	pdoptomog: program to perform Doppler tomography using a fast maximum
    	entropy algorithm on an extracted spectral line
    	mdoptomog: module holding all declared program variables

  scripts/gnu/

  - scripts for Gnuplot visualisation of the model 3d spatial construct

  scripts/idl/

  - scripts for IDL visualisation of Doppler tomography results

  scripts/shell/

  - scripts for folder and file management
  
********************************************************************************

The input data are organised in the following folder:

  sources/<source name>/in/, e.g., sources/mcv/in/

  - input for Step 1:

    -- specprepare.in, text file containing spectra preparation parameters

  - input for Step 2:

    -- specextract.in, text file containing spectral line extraction parameters

  - input for Step 3:

    -- doptomog.in, text file containing Doppler tomography parameters

  - input for Step 5:

    -- binarymodel.in, text file containing binary parameters

  sources/<source name>/in/spectra/, e.g., sources/mcv/in/spectra/

  - spectra input for Step 1:

    -- <source name>, e.g., cv, file containing list of spectra file names,
       corresponding phase and phase interval (if applicable)

    -- <spectra file name> (multiple), e.g., mcv001.txt, mcv002.txt. etc., files
       containing wavelength and flux

********************************************************************************

The output data are organised in the following folder:

  sources/<source name>/out/spectra/, e.g., sources/mcv/out/spectra/

  - output from Step 1:

    -- specprepare.out, input for Step 2

  - output from Step 2:

    -- specextract.out, input for Step 3

  sources/<source name>/out/doptomog/, e.g., sources/mcv/out/doptomog/

  - output from Step 3:

    -- doptomog.<0=standard/1=inside-out>.log, e.g., doptomog.0.log,
       a log of some of the calculations from the maximum entropy algorithm

    -- doptomog.<0=standard/1=inside-out>.out, e.g., doptomog.0.out,
       main output file containing (amongst other) the reconstructed spectra
       and tomogram, i.e., input for Steps 4 and 6

    -- halfphases/

       - halfphases.<0=standard/1=inside-out>.out, e.g., halfphases.0.out,
         a log of the consecutive half phases processed

       for n consecutive half phases:

       - doptomog.<0=standard/1=inside-out>.<i=0...n-1>.out, e.g.,
         doptomog.0.0.out, main output file containing (amongst other) the
         reconstructed spectra and tomogram for the i'th half phase, i.e.,
         input for Steps 4 and 6

    -- fluxmodmap/

       - fluxmodmap.<0=standard/1=inside-out>.out, e.g., fluxmodmap.0.out,
         main output file containing (amongst other) the n summed reconstructed
         spectra and tomograms, as well as the flux modulation amplitude and
         phase of maximum flux maps, i.e., input for Steps 4 and 6

  - output from Step 4:

    -- avgp.<0=standard/1=inside-out>.ps, e.g., avgp.0.ps,
       averaged line profile

    -- doptomog.<0=standard/1=inside-out>.ps, e.g., doptomog.0.ps,
       quick look results

    -- specin.<0=standard/1=inside-out>.ps, e.g., specin.0.ps,
       trailed input spectra

    -- specre.<0=standard/1=inside-out>.ps, e.g., specre.0.ps,
       trailed reconstructed spectra

    -- halfphases/

       for n consecutive half phases:

       - avgp.<0=standard/1=inside-out>.<i=0...n-1>.ps, e.g., avgp.0.0.ps,
         averaged line profile for the i'th half phase

       - doptomog.<0=standard/1=inside-out>.<i=0...n-1>.ps, e.g.,
         doptomog.0.0.ps, quick look results for the i'th half phase

       - specin.<0=standard/1=inside-out>.<i=0...n-1>.ps, e.g., specin.0.0.ps,
         trailed input spectra for the i'th half phase

       - specre.<0=standard/1=inside-out>.<i=0...n-1>.ps, e.g., specre.0.0.ps,
         trailed reconstructed spectra for the i'th half phase

    -- fluxmodmap/

       - avgp.<0=standard/1=inside-out>.ps, e.g., avgp.0.ps,
         averaged line profile for the n summed half phases

       - doptomog.<0=standard/1=inside-out>.ps, e.g., doptomog.0.ps,
          quick look results for the n summed half phases

       - specin.<0=standard/1=inside-out>.ps, e.g., specin.0.ps,
         trailed input spectra for the n summed half phases

       - specre.<0=standard/1=inside-out>.ps, e.g., specre.0.ps,
         trailed reconstructed spectra for the n summed half phases

  - output from Step 6:

    -- dopmap.<0=standard/1=inside-out>.ps, e.g., dopmap.0.ps,
       tomogram without model velocity profile overlay

    -- dopmap.<0=standard/1=inside-out>.vmod.ps, e.g., dopmap.0.vmod.ps,
       tomogram with model velocity profile overlay

    -- halfphases/

       for n consecutive half phases:

       - dopmap.<0=standard/1=inside-out>.<i=0...n-1>.ps, e.g., dopmap.0.0.ps,
         tomogram without model velocity profile overlay for the i'th half phase

       - dopmap.<0=standard/1=inside-out>.<i=0...n-1>.vmod.ps, e.g.,
         dopmap.0.0.vmod.ps, tomogram with model velocity profile overlay for
         the i'th half phase

    -- fluxmodmap/

       - dopmap.<0=standard/1=inside-out>.ps, e.g., dopmap.0.ps,
         tomogram without model velocity profile overlay for the n summed half
         phases

       - dopmap.<0=standard/1=inside-out>.vmod.ps, e.g., dopmap.0.vmod.ps,
         tomogram with model velocity profile overlay for the n summed half
         phases

       - moduamp.<0=standard/1=inside-out>.ps, e.g., moduamp.0.ps,
         flux modulation amplitude map without model velocity profile overlay

       - moduamp.<0=standard/1=inside-out>.vmod.ps, e.g., moduamp.0.vmod.ps,
         flux modulation amplitude map without model velocity profile overlay

       - modupha.<0=standard/1=inside-out>.ps, e.g., modupha.0.ps,
         flux modulation phase-offset map without model velocity profile overlay

       - modupha.<0=standard/1=inside-out>.vmod.ps, e.g., modupha.0.vmod.ps,
         flux modulation phase-offset map with model velocity profile overlay

       - modupham.<0=standard/1=inside-out>.ps, e.g., modupham.0.ps,
         phase of maximum flux map without model velocity profile overlay

       - modupham.<0=standard/1=inside-out>.vmod.ps, e.g., modupham.0.vmod.ps,
         phase of maximum flux map with model velocity profile overlay

       - moduphap.<0=standard/1=inside-out>.ps, e.g., moduphap.0.ps,
         filtered phase of maximum flux map without model velocity profile
         overlay

       - moduphap.<0=standard/1=inside-out>.vmod.ps, e.g., moduphap.0.vmod.ps,
         filtered phase of maximum flux map with model velocity profile overlay

  sources/<source name>/out/binarymodel/gnu/, e.g.,
   sources/mcv/out/binarymodel/gnu/

  - output from Step 5:

    -- various files, input for Step 7

  - output from Step 7:

    -- various subfolders and/or files depending on selected terminal

  sources/<source name>/out/binarymodel/idl/, e.g.,
   sources/mcv/out/binarymodel/idl/

  - output from Step 5:

    -- various files, input for Step 6

********************************************************************************

!******************************************************************************
!
!    mfunctions.f95 (part of doptomog package v2.0)
!    Copyright (C) 2015  Enrico J. Kotze ejk@saao.ac.za
!
!    This program is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    This program is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with this program.  If not, see <http://www.gnu.org/licenses/>.
!
!******************************************************************************
module mfunctions
!******************************************************************************

!******************************************************************************
	use mconstants
	implicit none
!******************************************************************************

!******************************************************************************
contains
!******************************************************************************

!******************************************************************************
	subroutine polarCoords(x, y, vphi, r)

		! determine polar coordinates
		real(kind(1d0)), intent(in)		::	x, y
		double precision, intent(out)	::	vphi, r
		integer							::	Q

		! calculate radius
		r = sqrt(x**2 + y**2)
		! get quadrant
		Q = quadrant(x, y)
		! calculate vphi
		vphi = 0.
		if (x /= 0) then
			vphi = atan(y / x) + int(0.5 * Q) * PI
		else
			select case (Q)
			case(1)
				vphi = 0.5d0 * PI
			case(4)
				vphi = 1.5d0 * PI
			end select
		end if

		return

	end subroutine polarCoords
!******************************************************************************

!******************************************************************************
	subroutine sphericalCoords(x, y, z, theta, vphi, r)

		! determine polar coordinates
		real(kind(1d0)), intent(in)		::	x, y, z
		double precision, intent(out)	::	theta, vphi, r
		integer							::	Q

		! calculate radius
		r = sqrt(x**2 + y**2 + z**2)
		! calculate theta (polar angle)
		theta = acos(z / r)
		! get xy-quadrant
		Q = quadrant(x, y)
		! calculate vphi (azimuthal angle)
		vphi = 0.
		if (x /= 0) then
			vphi = atan(y / x) + int(0.5 * Q) * PI
		else
			select case (Q)
			case(1)
				vphi = 0.5d0 * PI
			case(4)
				vphi = 1.5d0 * PI
			end select
		end if

		return

	end subroutine sphericalCoords
!******************************************************************************

!******************************************************************************
	integer function quadrant(x, y)

		real(kind(1d0)), intent(in)		::	x, y
		! determine quadrant
		if (x >= 0 .and. y >= 0) quadrant = 1
		if (x <  0 .and. y >= 0) quadrant = 2
		if (x <  0 .and. y <  0) quadrant = 3
		if (x >= 0 .and. y <  0) quadrant = 4

		return

	end function quadrant
!******************************************************************************

!******************************************************************************

!******************************************************************************
	subroutine inoutCoords(vmax, dv, v, vprime)

		! determine inside-out coordinates
		real(kind(1d0)), intent(in)					::	vmax, dv, v
		real(kind(1d0)), intent(out)				::	vprime

		! determine inside-out coordinates
		! linearly scaled inside-out
		vprime = max((vmax + 0.5d0 * dv) - v, 0d0)

		return

	end subroutine inoutCoords
!******************************************************************************

!******************************************************************************
	subroutine interpolate(x1, y1, m, x2, y2, n)

		integer, intent(in)								::	m, n
		real(kind(1d0)), dimension(m), intent(in)		::	x1(m)
		real(kind(1d0)), dimension(0:m), intent(in)		::	y1(0:m)
		real(kind(1d0)), dimension(n), intent(in)		::	x2(n)
		real(kind(1d0)), dimension(0:n), intent(out)	::	y2(0:n)
		integer											::	i, j

		y2 = 0d0
		do j = 1, n
			do i = 1, m
				if (x2(j) == x1(i)) then
					y2(j) = y1(i)
					exit
				end if
				if(x2(j) < x1(i)) then
					! interpolate
					y2(j) = y1(i-1) + &
						(y1(i) - y1(i-1)) * (x2(j) - x1(i-1)) / (x1(i) - x1(i-1))
					exit
				end if
			end do
		end do

		return

	end subroutine interpolate
!******************************************************************************

!******************************************************************************
	subroutine interpolate1(n, arrA, arrB, x, y)

		! This subroutine interpolates arrB for a value x from arrA
		integer, intent(in)								::	n
		real(kind(1d0)), intent(in), dimension(n)		::	arrA, arrB
		real(kind(1d0)), intent(in)						::	x
		real(kind(1d0)), intent(out)					::	y
		real(kind(1d0))									::	a1, a2, b1, b2
		integer											::	i

		y = 0.; a1 = 0.; a2 = 0.; b1 = 0.; b2 = 0.
		do i = 2, n
			a1 = arrA(i); a2 = arrA(i-1)
			b1 = arrB(i); b2 = arrB(i-1)
			select case (a1 < x)
			case (.TRUE.)
				! do nothing, continue with do loop...
			case (.FALSE.)
				select case (a1 == x)
				case (.TRUE.)
					y = b1
					return
				case (.FALSE.)
					y = b2 + (x - a2) * (b1 - b2) / (a1 - a2)
					return
				end select
			end select
		end do

		return

	end subroutine interpolate1
!******************************************************************************

!******************************************************************************
	subroutine multivariateLeastSquares(m, y, x, a)

		! multivariate least squares fit y = a0 + a1*x1 + a2*x2 + ... + am*xm
		integer, intent(in)								::	m
		real(kind(1d0)), intent(in)						::	y
		real(kind(1d0)), intent(in), dimension(0:m)		::	x
		real(kind(1d0)), intent(out), dimension(0:m)	::	a
		real(kind(1d0)), dimension(m+1,m+1)				::	aX
		real(kind(1d0)), dimension(m+1,1)				::	aY
		integer											::	i, j

		a = 0d0; aX = 0d0; aY = 0d0
		do i = 0, m
			do j = 0, m
				aX(i+1,j+1) = aX(i+1,j+1) + x(i) * x(j)
			end do
			aY(i+1,1) = aY(i+1,1) + y * x(i)
		end do
		aX = aX / dble(m + 1)
		aY = aY / dble(m + 1)
		call gaussj(aX, m, m, aY, 1, 1)
		do i = 0, m
			a(i) = round(aY(i+1,1), 6)
		end do

		return

	end subroutine multivariateLeastSquares
!******************************************************************************

!******************************************************************************
	real function round(a, dec)

		real(kind(1d0)), intent(in)	::	a
		integer, intent(in)			::	dec
		real(kind(1d0))				::	b

		b = a / abs(a)
		round = b * float(int(abs(a) * 10**dec + 0.5)) / 10**dec

		return

	end function round
!******************************************************************************

!******************************************************************************
	SUBROUTINE piksrt(n,arr,arr_ind)
		! Sorts an array arr(1:n) into ascending numerical order, by straight
		! insertion.
		! n is input; arr is replaced on output by its sorted rearrangement.
		INTEGER n
		REAL(kind(1d0)) arr(n),arr_ind(n)
		INTEGER i,j
		REAL(kind(1d0)) a,ind

		do j=2,n						! Pick out each element in turn.
			a=arr(j)
			ind=arr_ind(j)
			do i=j-1,1,-1				! Look for the place to insert it.
				if(arr(i).le.a) goto 10
				arr(i+1)=arr(i)
				arr_ind(i+1)=arr_ind(i)
			end do
			i=0
 	10		arr(i+1)=a					! Insert it.
 			arr_ind(i+1)=ind
		end do

		return

	END SUBROUTINE piksrt
!******************************************************************************

!******************************************************************************
	FUNCTION ran1(idum)

		! “Minimal” random number generator of Park and Miller with Bays-Durham
		! shuffle and added safeguards. Returns a uniform random deviate between
		! 0.0 and 1.0 (exclusive of the endpoint values). Call with idum a
		! negative integer to initialize; thereafter, do not alter idum between
		! successive deviates in a sequence. RNMX should approximate the largest
		! floating value that is less than 1.
		INTEGER idum,IA,IM,IQ,IR,NTAB,NDIV
		REAL ran1,AM,EPS,RNMX
		PARAMETER (IA=16807,IM=2147483647,AM=1./IM,IQ=127773,IR=2836)
		PARAMETER (NTAB=32,NDIV=1+(IM-1)/NTAB,EPS=1.2e-7,RNMX=1.-EPS)
		INTEGER j,k,iv(NTAB),iy
		SAVE iv,iy
		DATA iv /NTAB*0/, iy /0/

		if (idum.le.0.or.iy.eq.0) then
			idum=max(-idum,1)
			do j=NTAB+8,1,-1
				k=idum/IQ
				idum=IA*(idum-k*IQ)-IR*k
				if (idum.lt.0) idum=idum+IM
				if (j.le.NTAB) iv(j)=idum
			end do
			iy=iv(1)
		end if
		k=idum/IQ
		idum=IA*(idum-k*IQ)-IR*k
		if (idum.lt.0) idum=idum+IM
		j=1+iy/NDIV
		iy=iv(j)
		iv(j)=idum
		ran1=min(AM*iy,RNMX)

		return

	END FUNCTION ran1
!******************************************************************************

!******************************************************************************
	SUBROUTINE gaussj(a,n,nr,b,m,mr)

		! Linear equation solution by Gauss-Jordan elimination.
		! a(1:n,1:n) is an input matrix stored in an array of physical
		! dimensions nr by nr.
		! b(1:n,1:m) is an input matrix containing the m right-hand side
		! vectors, stored in an array of physical dimensions nr by mr.
		! On output, a(1:n,1:n) is replaced by its matrix inverse, and
		! b(1:n,1:m) is replaced by the corresponding set of solution vectors.
		! Parameter: NMAX is the largest anticipated value of n.
		!USE nrtype; USE nrutil, ONLY : nrerror
		INTEGER m,mr,n,nr,NMAX
		REAL(kind(1d0)) a(nr,nr),b(nr,mr)
		PARAMETER (NMAX=50)
		INTEGER i,icol,irow,j,k,l,ll,indxc(NMAX),indxr(NMAX),ipiv(NMAX)
		! The integer arrays ipiv, indxr and indxc are used for bookkeeping on
		! the pivoting.
		REAL big,dum,pivinv

		do j=1,n
			ipiv(j)=0
		enddo
		do i=1,n		! This is the main loop over the columns to be reduced.
			big=0.
			do j=1,n	! This is the outer loop of the search for a pivot element.
				if(ipiv(j).ne.1) then
					do k=1,n
						if (ipiv(k).eq.0) then
							if (abs(a(j,k)).ge.big) then
								big=abs(a(j,k))
								irow=j
								icol=k
							endif
						else if (ipiv(k).gt.1) then
							!pause 'singular matrix in gaussj'
							call nrerror('gaussj: singular matrix (1)')
						endif
					enddo
				endif
			enddo
			ipiv(icol)=ipiv(icol)+1
			! We now have the pivot element, so we interchange rows, if needed,
			! to put the pivot	element on the diagonal. The columns are not
			! physically interchanged, only relabeled:
			! indxc(i), the column of the ith pivot element, is the ith column
			! that is reduced, while indxr(i) is the row in which that pivot
			! element was originally located. If indxr(i)<>indxc(i) there is an
			! implied column interchange. With this form of bookkeeping, the
			! solution b's will end up in the correct order, and the inverse
			! matrix will be scrambled by columns.
			if (irow.ne.icol) then
				do l=1,n
					dum=a(irow,l)
					a(irow,l)=a(icol,l)
					a(icol,l)=dum
				enddo
				do l=1,m
					dum=b(irow,l)
					b(irow,l)=b(icol,l)
					b(icol,l)=dum
				enddo
			endif
			indxr(i)=irow		! We are now ready to divide the pivot row by
			indxc(i)=icol		! the pivot element, located at irow and icol.
			!if (a(icol,icol).eq.0.) pause 'singular matrix in gaussj'
			if (a(icol,icol).eq.0.) &
				call nrerror('gaussj: singular matrix (2)')
			pivinv=1./a(icol,icol)
			a(icol,icol)=1.
			do l=1,n
				a(icol,l)=a(icol,l)*pivinv
			enddo
			do l=1,m
				b(icol,l)=b(icol,l)*pivinv
			enddo
			do ll=1,n				! Next, we reduce the rows...
				if(ll.ne.icol) then	! ...except for the pivot one, of course.
					dum=a(ll,icol)
					a(ll,icol)=0.
					do l=1,n
						a(ll,l)=a(ll,l)-a(icol,l)*dum
					enddo
					do l=1,m
						b(ll,l)=b(ll,l)-b(icol,l)*dum
					enddo
				endif
			enddo
		enddo		! End of the main loop over columns of the reduction.
		do l=n,1,-1
			! It only remains to unscramble the solution in view of the column
			! interchanges. We do this by interchanging pairs of columns in the
			! reverse order that the permutation was built up.
			if(indxr(l).ne.indxc(l)) then
				do k=1,n
					dum=a(k,indxr(l))
					a(k,indxr(l))=a(k,indxc(l))
					a(k,indxc(l))=dum
				enddo
			endif
		enddo

		return			! And we are done.

	END SUBROUTINE gaussj
!******************************************************************************

!******************************************************************************
	SUBROUTINE nrerror(string)

		! Report a message, then die.
		CHARACTER(LEN=*), INTENT(IN)	::	string

		write (*, *) 'nrerror: ', string
		STOP 'program terminated by nrerror'

	END SUBROUTINE nrerror
!******************************************************************************

!******************************************************************************
	SUBROUTINE pause_here

		! subroutine to pause program; requiring user to re-initiate execution
		IMPLICIT NONE
		CHARACTER :: PAUSE

		WRITE(*,'(A)', ADVANCE = 'NO') 'Press < ENTER > to continue ==>'
		READ(*,'(A)') PAUSE

	END SUBROUTINE pause_here
!******************************************************************************

!******************************************************************************
end module mfunctions
!******************************************************************************

!******************************************************************************

!******************************************************************************
!
!    pbinarymodel.f95 (part of doptomog package v2.0)
!    Copyright (C) 2015  Enrico J. Kotze ejk@saao.ac.za
!
!    This program is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    This program is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with this program.  If not, see <http://www.gnu.org/licenses/>.
!
!******************************************************************************
program pbinarymodel
!******************************************************************************

!******************************************************************************
	use mconstants
	use mfunctions
	use mbinarymodel
	implicit none

	integer											::	i
	character(len=255)								::	arg

	! current working directory
	call getcwd(cwd)

	! input parameters from command line 
	do i = 1, command_argument_count()
		call get_command_argument(i, arg)
		if (i == 1) read(arg, *) IDL
		if (i == 2) read(arg, '(a)') inpath
		if (i == 3) read(arg, '(a)') outpath
		! ... that's it for now...
	end do

	! input parameters from 'binarymodel.in'
	call inputParameters()

	! calculate binary parameters
	call binaryParameters()

	! calculate and output binary centres of mass
	call centresOfMass()

	! calculate and output binary Roche lobes velocity and spatial coordinates
	call rocheLobes()

	! calculate and output ballistic stream velocity and spatial coordinates
	call ballisticStream()

	! calculate and output accretion disc velocity and spatial coordinates
	call accretionDisc()

	! calculate and output magnetic stream velocity and spatial coordinates
	call magneticStream()

	! calculate and output Keplerian trace velocity coordinates
	call keplerianTrace()

	! calculate and output general velocity information
	call velocityInfo()

	! output parameters for plotting routines
	call outputParameters()

!******************************************************************************
contains	
!******************************************************************************

!******************************************************************************

!******************************************************************************
	subroutine inputParameters()

		! get input from 'binarymodel.in'
		open(unit = 1, file = trim(inpath)//'binarymodel.in')
		read(1, *) mCV
		read(1, *) M1
		read(1, *) qm
		read(1, *) inc
		read(1, *) Porb
		read(1, *) Pspin
		read(1, *) azE
		read(1, *) azMs
		read(1, *) azMe
		read(1, *) azMi
		read(1, *) Psi
		read(1, *) beta

		read(1, *) vDi
		read(1, *) cmInd

		close(1)

		! validate mass ratio qm
		if (abs(qm - 1) < 1e-4) qm = 1e-4
		! validate input for magnetic stuff...
		if (mCV >= 1) then
			if (Pspin == 0d0) Pspin = Porb
			if (mCV == 1 .and. azE < azMe) azE = azMe
			if (azMi == 0.) then
				call nrerror('inputParameters: check magnetic related input!')
			end if
		end if

		! 360 degree array
		do i = 0, nDp
			theta360(i) = twoPI * float(i) / float(nDp)
		end do

		return

	end subroutine inputParameters
!******************************************************************************

!******************************************************************************
	subroutine binaryParameters()

		real(kind(1d0))	::	Omega

		! system centre of mass
		comSys = qm / (1. + qm)
		! assumed centre of mass
		com = 0.; if (cmInd == 0) com = comSys
		comAdj = com - comSys
		! sine of the inclination in radians
		sini = sin(inc * PI / 180.)
		! angular velocity = 2*PI / orbital period in seconds
		Omega = twoPI / (86400. * Porb)
		! binary separation
		aa = (GC * M1 * MSun * (1. + qm))**(1. / 3.) / Omega**(2. / 3.)
		! binary velocity scaling factor
		bvs = aa * Omega / vf

		return

	end subroutine binaryParameters
!******************************************************************************

!******************************************************************************
	subroutine centresOfMass()

		! initialise centres of mass spatial and velocity coordinates
		sCOM = 0.; vCOM = 0.
		! system centre of mass: x spatial and y velocity coordinates
		sCOM(0,x) = comSys - com
		vCOM(0,y) = (comSys - com) * bvs * sini
		! primary centre of mass: x spatial and y velocity coordinates
		sCOM(1,x) = 0. - com
		vCOM(1,y) = (0. - com) * bvs * sini
		! secondary centre of mass: x spatial and y velocity coordinates
		sCOM(2,x) = 1. - com
		vCOM(2,y) = (1. - com) * bvs * sini
		! output centres of mass velocity and spatial coordinates
		call centresOfMassOutput()

		return

	end subroutine centresOfMass
!******************************************************************************

!******************************************************************************
	subroutine centresOfMassOutput()

		integer										::	i, funit

		! open output files
		call centresOfMassOutputFiles()
		! loop for system(0), primary(1) and secondary(2) centres of mass
		do i = 0, 2
			if (i == 0) funit = 1
			if (i > 0) funit = 3
			! calculate polar velocity coordinates for centre of mass
			call polarCoords(vCOM(i,x), vCOM(i,y), theta, v)
			! write velocity coordinates for centre of mass to file
			call outputEntry(funit, 1, 1, vCOM(i,x), vCOM(i,y), 0d0, theta, 0d0, v)
			! write spatial coordinates for centre of mass to file
			call outputEntry(funit + 1, 2, 1, sCOM(i,x), sCOM(i,y), 0d0)
		end do
		! close output files
		call closeOutputFiles()

		return

	end subroutine centresOfMassOutput
!******************************************************************************

!******************************************************************************
	subroutine centresOfMassOutputFiles()

		! system com velocity coordinates
		open(unit = 1, file = trim(outpath)//'vCOM.out')
		call outputHeader(1, 1)
		! system com spatial coordinates
		open(unit = 2, file = trim(outpath)//'sCOM.out')
		call outputHeader(2, 2)
		! primary and secondary velocity coordinates relative to system com
		open(unit = 3, file = trim(outpath)//'vBinary.out')
		call outputHeader(3, 1)
		! primary and secondary spatial coordinates relative to system com
		open(unit = 4, file = trim(outpath)//'sBinary.out')
		call outputHeader(4, 2)
		! # of output files
		nF = 4

		return

	end subroutine centresOfMassOutputFiles
!******************************************************************************

!******************************************************************************
	subroutine rocheLobes()

		real(kind(1d0)), dimension(nRl)				::	xRlm, yRlm
		real(kind(1d0)), dimension(nRl)				::	vxRlm, vyRlm
		real(kind(1d0)), dimension(3,nRl,0:nDp)		::	sXYZ
		real(kind(1d0))								::	qS, rS
		integer										::	m, n, i, j

		n = nRl / 2
		! allocate dimension to xRl(:,:), yRl(:,:), rRl(:,:), chi(:), phi(:)
		allocate(xRl(2,nRl), yRl(2,nRl), rRl(n,n), chi(n), phi(n))
		! calculate RL1 [a] from centre of primary to inner Lagrangian point
		call calculateRL1()
		! initialise 3D spatial coordinate array
		sXYZ = 0.
		! loop for # of Roche lobes: primary (M1), secondary (M2)
		do m = 1, 2
			! mass ratio and radius for Roche surface
			if (m == 1) qS = 1 / qm
			if (m == 2) qS = qm
			if (m == 1) rS = 1 - RL1
			if (m == 2) rS = RL1
			! calculate Roche surface
			call rocheSurface(qS, rS)
			! populate spatial x and y arrays
			do i = 1, n
				xRl(m,i) = rRl(i,1) * cos(chi(i))
				if (m == 2) xRl(m,i) = 1d0 - xRl(m,i)
				yRl(m,i) = rRl(i,1) * sin(chi(i))
				if (m == 2) yRl(m,i) = 0d0 - yRl(m,i)
				j = nRl + 1 - i
				xRl(m,j) = xRl(m,i)
				yRl(m,j) = 0d0 - yRl(m,i)
			end do
			! spatial coordinates of Roche lobe
			! adjust x coordinates with assumed system com
			xRlm = xRl(m,1:nRl) - com
			yRlm = yRl(m,1:nRl)
			! 3D spatial coordinates
			do i = 1, nRl / 2 + 1
				do j = 0, nDp, 12
					sXYZ(x,i,j) = xRlm(i)
					sXYZ(y,i,j) = yRlm(i) * cos(theta360(j))
					sXYZ(z,i,j) = yRlm(i) * sin(theta360(j))
				end do
			end do
			! velocity coordinates of Roche lobe
			vxRlm = xRlm * bvs * sini
			vyRlm = yRlm * bvs * sini
			! output Roche lobe velocity and spatial coordinates
			call rocheLobesOutput(m, vxRlm, vyRlm, xRlm, yRlm, sXYZ)
		end do

		return

	end subroutine rocheLobes
!******************************************************************************

!******************************************************************************
	subroutine rocheSurface(qS, rS)

		! Roche surface around M1 and M2, coordinates on surface are chi, phi.
		! qS: mass ratio for surface,
		! rS: radius of surface at point facing surface
		real(kind(1d0)), intent(in)					::	qS, rS
		! max no of iterations
		integer, parameter							::	im = 20
		character(len=50)							::	msg = '', frmt = ''
		real(kind(1d0))								::	rS0, fS0, fS, rRl0
		real(kind(1d0))								::	x, y, z, r0, pR
		integer										::	i, j, k, n

		rRl = 0d0; chi = 0d0; phi = 0d0

		n = nRl / 2
		rS0 = 1 - rS
		call rochePotential(qS, rS0, 0d0, 0d0, pR, fS0)
		rRl0 = (1 - PI / n) * rS0

		do i = 1, n
			phi(i) = twoPI * float(i - 1) / n
			rRl(1,i) = rS0
			do j = 2, n
				chi(j) = PI * float(j - 1) / (n - 1)
				x = cos(chi(j))
				y = sin(chi(j)) * cos(phi(i))
				z = sin(chi(j)) * sin(phi(i))
				k = 0
				fS = 1d0
				do while (k < im .and. abs(fS - fS0) > 1e-4)
					k = k + 1
					r0 = rRl0
					call rochePotential(qS, r0 * x, r0 * y, r0 * z, pR, fS)
					rRl0 = r0 - (fS - fS0) / pr
					if (rRl0 > rS0) rRl0 = rS0
				end do
				if (k >= im) then
					frmt = '('' j, i, chi, phi'', 2i4, 2f7.3)'
					write(msg, trim(frmt)) j, i, chi(j), phi(i)
					call nrerror('no convergence in rocheSurface:'//msg)
				end if
				rRl(j,i) = rRl0
			end do
		end do

		return

	end subroutine rocheSurface
!******************************************************************************
	
!******************************************************************************
	subroutine rochePotential(qS, x, y, z, pR, fS)

		! Roche potential: coordinates centered on Roche surface
		! pR is gradient in radius from Roche surface
		! fS is Roche potential at Roche surface
		real(kind(1d0)), intent(in)					::	qS, x, y, z
		real(kind(1d0)), intent(out)				::	pR, fS
		real(kind(1d0))								::	r, r1, r2, rh, st, cf

		! first transform to spherical coordinates w/r rotation axis
		r = sqrt(x**2 + y**2 + z**2)
		if (r == 0) call nrerror('r = 0 in rochePotential')
		rh = sqrt(x**2 + y**2)
		st = rh / r
		if (rh == 0) then
			cf = 1
		else
			cf = x / rh
		end if
		r1 = sqrt(1 + r**2 - 2 * r * cf * st)
		r2 = 1 / (1 + qS)
		fS = -1 / r - 1 / qS / r1 - 0.5 * (1 + 1 / qS) * &
			(r2**2 + (r * st)**2 - 2 * r2 * r * cf * st)
		pR = 1 / r**2 + 1 / qS / (r1**3) * (r - cf * st) - &
			(1 + 1 / qS) * (r * st**2 - r2 * cf * st)

		return

	end subroutine rochePotential
!******************************************************************************

!******************************************************************************
	subroutine rocheLobesOutput(m, vxRl, vyRl, xRl, yRl, sXYZ)

		integer, intent(in) 						::	m
		real(kind(1d0)), dimension(nRl), intent(in)	::	vxRl, vyRl, xRl, yRl
		real(kind(1d0)), dimension(3,nRl,0:nDp), intent(in)	::	sXYZ
		integer 									::	i, j

		! open output files
		call rocheLobesOutputFiles(m)
		! velocity and spatial coordinates
		do i = 1, nRl, 2
			! calculate polar velocity coordinates for Roche lobe
			call polarCoords(vyRl(i), vxRl(i), theta, v)
			! write velocity coordinates to file
			call outputEntry(1, 1, 0, vyRl(i), vxRl(i), 0d0, theta, 0d0, v)
			! write spatial coordinates to file
			call outputEntry(2, 2, 0, xRl(i), yRl(i), 0d0)
		end do
		! 3D spatial coordinates
		do i = 1, nRl / 2 + 1, 12
			do j = 0, nDp, 12
				! write 3D spatial coordinates to file
				call outputEntry(3, 2, 0, sXYZ(x,i,j), sXYZ(y,i,j), sXYZ(z,i,j))
			end do
			if (IDL == 0) write(3, '(a1)') ''
		end do
		! close output files
		call closeOutputFiles()

		return

	end subroutine rocheLobesOutput
!******************************************************************************

!******************************************************************************
	subroutine rocheLobesOutputFiles(m)

		integer, intent(in) 						::	m
		character(len=10)							::	theLobe

		! set file name
		if (m == 1) theLobe = 'Primary'
		if (m == 2) theLobe = 'Secondary'
		! Roche lobe velocity coordinates
		open(unit = 1, file = trim(outpath)//'v'//trim(theLobe)//'.out')
		call outputHeader(1, 1)
		! Roche lobe spatial coordinates
		open(unit = 2, file = trim(outpath)//'s'//trim(theLobe)//'.out')
		call outputHeader(2, 2)
		! Roche lobe 3D spatial coordinates
		open(unit = 3, file = trim(outpath)//'s3D'//trim(theLobe)//'.out')
		call outputHeader(3, 2)
		! # of output files
		nF = 3

		return

	end subroutine rocheLobesOutputFiles
!******************************************************************************

!******************************************************************************
	subroutine ballisticStream()

		real(kind(1d0)), dimension(nMax)			::	xB, yB, rB
		complex(kind(1d0)), dimension(nMax)			::	vB, vKB
		complex(kind(1d0))							::	s, w, sp, wp, sM1, sM2
		complex(kind(1d0))							::	ds, dw, wK, wI, ur
		real(kind(1d0))								::	phase, dphase, vK, rK
		! t = time and dt = time increment
		real(kind(1d0))								::	t = 0d0, dt = 1e-5
		real(kind(1d0))								::	azMax

		! spatial coordinates of M1 and M2
		sM1 = 0d0 - comSys; sM2 = 1 - comSys
		! start at L1 - eps with zero velocity
		s = cmplx(RL1 - comSys - eps, 0); ds = 0d0
		w = 0d0; dw = 0d0
		! initialise loop variables: nBs (count) and phase
		nBs = 0; phase = 0d0
		! loop until max # of array points or max phase
		do while(nBs < nMax .and. phase < phaseMax)
			! increment count
			nBs = nBs + 1
			! calculate position and velocity
			call rungeKutta(dt, s, w, sM1, sM2, ds, dw)
			! add deltas
			s = s + ds; w = w + dw; t = t + dt
			! update time increment dt, if necessary
			if (abs(ds) / abs(s) > 0.020) dt = dt / 2
			if (abs(ds) / abs(s) < 0.005) dt = 2 * dt
			! calculate delta phase and increment phase
			dphase = -aimag(s * conjg(s - ds)) / abs(s) / abs(s - ds)
			phase = phase + dphase
			! velocity in inertial frame
			wI = w + cmplx(0, 1) * s
			! vector normal to circular Kepler orbit
			rK = abs(s - sM1)
			! unit vector in rK
			ur = conjg(s - sM1) / rK
			! Kepler velocity in potential of M1, relative to M1
			vK = 1 / sqrt(rK * (1 + qm))
			! same but relative to comSys, i.e., velocity in inertial frame
			wK = -vK * ur * cmplx(0, 1) + conjg(cmplx(0, -comSys))
			! populate work arrays
			xB(nBs) = s + comSys
			yB(nBs) = -aimag(s)
			vB(nBs) = wI								
			vKB(nBs) = conjg(wK)
		end do
		! allocate dimensions to output arrays
		allocate(xBs(nBs), yBs(nBs), vxBs(nBs), vyBs(nBs), vxKt(nBs), vyKt(nBs))
		! populate output arrays
		xBs = xB(1:nBs); yBs = yB(1:nBs)
		vxBs = real(vB(1:nBs)); vyBs = aimag(vB(1:nBs))
		vxKt = real(vKB(1:nBs)); vyKt = aimag(vKB(1:nBs))
		! 'negatise' ballistic stream y spatial coordinates
		yBs = -yBs
		! velocity coordinates of ballistic stream
		vxBs = vxBs * bvs * sini
		vyBs = (vyBs - comAdj) * bvs * sini
		! calculate ballistic stream azimuth measured from line M1-M2
		allocate(azBs(nBs))
		azBs = atan(yBs / xBs)
		azBs = azBs + merge(1, 0, xBs < 0.) * PI
		azBs = azBs * 180. / PI
		azMax = min(265., azE)
		! determine # of points for ballistic stream up to required azimuth
		nBa = 0
		do while (azBs(nBa + 1) < (azMax + 1.) .and. (nBa + 1) < (nBs - 1))
			nBa = nBa + 1
		end do
		! output ballistic stream velocity and spatial coordinates
		call ballisticStreamOutput()

		return

	end subroutine ballisticStream
!******************************************************************************

!******************************************************************************
	subroutine rungeKutta(dt, s, w, sM1, sM2, ds, dw)

		! Runge-Kutta...
		real(kind(1d0)), intent(in)			::	dt
		complex(kind(1d0)), intent(in)		::	s, w, sM1, sM2
		complex(kind(1d0)), intent(out)		::	ds, dw
		complex(kind(1d0))					::	sp, sa, wp, wa
		complex(kind(1d0))					::	hs0, hs1, hs2, hs3
		complex(kind(1d0))					::	hw0, hw1, hw2, hw3

		sa = s
		wa = w
		call equationOfMotion(sa, wa, sM1, sM2, sp, wp)
		hs0 = sp * dt
		hw0 = wp * dt

		sa = s + hs0 / 2
		wa = w + hw0 / 2
		call equationOfMotion(sa, wa, sM1, sM2, sp, wp)
		hs1 = sp * dt
		hw1 = wp * dt

		sa = s + hs1 / 2
		wa = w + hw1 / 2
		call equationOfMotion(sa, wa, sM1, sM2, sp, wp)
		hs2 = sp * dt
		hw2 = wp * dt

		sa = s + hs2
		wa = w + hw2
		call equationOfMotion(sa, wa, sM1, sM2, sp, wp)
		hs3 = sp * dt
		hw3 = wp * dt

		ds = (hs0 + 2 * hs1 + 2 * hs2 + hs3) / 6
		dw = (hw0 + 2 * hw1 + 2 * hw2 + hw3) / 6

		return

	end subroutine rungeKutta
!******************************************************************************

!******************************************************************************
	subroutine equationOfMotion(s, w, sM1, sM2, sp, wp)

		! equation of motion routine
		complex(kind(1d0)), intent(in)		::	s, w, sM1, sM2
		complex(kind(1d0)), intent(out)		::	sp, wp
		complex(kind(1d0))					::	s1, s2

		sp = w
		s1 = s - sM1
		s2 = s - sM2
		! change in velocity under gravity and Coriolis force
		wp = s - (s1 / (abs(s1))**3 + qm * s2 / (abs(s2))**3) / (1 + qm) &
			- cmplx(0, 2) * w
		! ... and magnetic drag for polars
		if (mCV == 1) wp = wp - exp(-sqrt(s1**2 + s2**2)) * w

		return

	end subroutine equationOfMotion
!******************************************************************************

!******************************************************************************
	subroutine ballisticStreamOutput()

		integer										::	i

		! open output files
		call ballisticStreamOutputFiles()
		! ballistic stream velocity and spatial coordinates
		do i = 1, nBa
			! calculate polar velocity coordinates for ballistic stream
			call polarCoords(vxBs(i), vyBs(i), theta, v)
			! write velocity coordinates to file
			call outputEntry(1, 1, 0, vxBs(i), vyBs(i), 0d0, theta, 0d0, v)
			! write spatial coordinates to file
			! adjust x coordinates with assumed system com
			call outputEntry(2, 2, 0, xBs(i) - com, yBs(i), 0d0)
		end do
		! ballistic stream ALL spatial coordinates
		do i = 1, nBs
			! write spatial coordinates to file
			! adjust x coordinates with assumed system com
			call outputEntry(3, 2, 0, xBs(i) - com, yBs(i), 0d0)
		end do
		! close output files
		call closeOutputFiles()

		return

	end subroutine ballisticStreamOutput
!******************************************************************************

!******************************************************************************
	subroutine ballisticStreamOutputFiles()

		! ballistic stream velocity coordinates
		open(unit = 1, file = trim(outpath)//'vStreamBal.out')
		call outputHeader(1, 1)
		! ballistic stream spatial coordinates
		open(unit = 2, file = trim(outpath)//'sStreamBal.out')
		call outputHeader(2, 2)
		! ballistic stream spatial coordinates (all)
		open(unit = 3, file = trim(outpath)//'sStreamAll.out')
		call outputHeader(3, 2)
		! # of output files
		nF = 3

		return

	end subroutine ballisticStreamOutputFiles
!******************************************************************************

!******************************************************************************
	subroutine accretionDisc()

		real(kind(1d0))								::	vK, Rs
		integer										::	i, j

		if (mCV== 0 .or. mCV == 2) then
			rAd = 0d0
			! calculate inner disc radius [binary separation] (Eq 2.81 Warner 1995)
			if (vDi > 0d0) rAd(1) = (GC * M1 * MSun * sini**2 / (vDi * vf)**2) / aa
			! calculate outer disc radius [binary separation]
			if (qm <= 0.3) then
				! 3:1 resonance (Eq 3.39 Warner 1995 -- P = Porb / 3)
				rAd(nAd) = round((1./3.)**(2./3.) * (1. + qm)**(-1./3.), 2)
			else
				! r(tidal), where r(tidal) = 0.6a / (1 + q) (Paczynski 1977)
				rAd(nAd) = 0.6 / (1. + qm)
			end if
			! calculate outer disc height: 5% of outer disc radius
			hAd(nAd) = 0.05 * rAd(nAd)
			! calculate inner disc height: 2.5% of outer disc height
			hAd(1) = 0.025 * hAd(nAd)
			! calculate other radii as a fraction of outer disc radius
			do j = 2, nAd - 1
				rAd(j) = rAd(nAd) * float(j - 1) / float(nAd - 1)
			end do
			! calculate and output disc coordinates for all disc radii
			do j = 1, nAd
				! Keplerian velocity
				vK = sqrt(GC * M1 * MSun / (rAd(j) * aa)) / vf
				! velocity coordinates
				vxAd(j,0:nDp) = vK * cos(theta360) * sini
				vyAd(j,0:nDp) = vK * sin(theta360) * sini + vCOM(1,y)
				! spatial coordinates
				! adjust x coordinates with assumed system com
				xAd(j,0:nDp) = rAd(j) * cos(theta360) - com
				yAd(j,0:nDp) = rAd(j) * sin(theta360)
				! output disc velocity and spatial coordinates
				call accretionDiscOutput(j)
			end do
			! output 3D spatial coordinates (using inner and outer disc)
			call accretionDisc3DOutput()
			! calculate and output disc reference points coordinates
			call accretionDiscReferencePoints()
		end if

		return

	end subroutine accretionDisc
!******************************************************************************

!******************************************************************************
	subroutine accretionDiscOutput(j)

		integer, intent(in)							::	j
		integer										::	i

		! open output files
		call accretionDiscOutputFiles(j)
		! accretion disc radius velocity and spatial coordinates
		! loop for # of data points
		do i = 0, nDp
			! calculate polar velocity coordinates for disc radius
			call polarCoords(vxAd(j,i), vyAd(j,i), theta, v)
			! write velocity coordinates to file
			call outputEntry(1, 1, 0, vxAd(j,i), vyAd(j,i), 0d0, theta, 0d0, v)
			! write spatial coordinates to file
			call outputEntry(2, 2, 0, xAd(j,i), yAd(j,i), 0d0)
		end do
		if (j > 1 .and. j < nAd) then
			if (IDL == 0) write(1,'(a1)') ''
			if (IDL == 0) write(2,'(a1)') ''
		end if
		! close output files
		call closeOutputFiles()

		return

	end subroutine accretionDiscOutput
!******************************************************************************

!******************************************************************************
	subroutine accretionDiscOutputFiles(j)

		integer, intent(in)							::	j
		character(len=10)							::	theDisc, accessFile
		logical										::	writeHeader

		! set accessFile and writeHeader default values
		accessFile = 'SEQUENTIAL'
		writeHeader = .true.
		! set file name
		if (j == 1) theDisc = 'DiscInner'
		if (j > 1 .and. j < nAd) then
			theDisc = 'Disc'
			if (j > 2) then
				! override accessFile and writeHeader
				accessFile = 'APPEND'
				writeHeader = .false.
			end if
		end if
		if (j == nAd) theDisc = 'DiscOuter'
		! inner accretion disc velocity coordinates
		open(unit = 1, file = trim(outpath)//'v'//trim(theDisc)//'.out', &
			access = trim(accessFile))
		if (writeHeader) call outputHeader(1, 1)
		! inner accretion disc spatial coordinates
		open(unit = 2, file = trim(outpath)//'s'//trim(theDisc)//'.out', &
			access = trim(accessFile))
		if (writeHeader) call outputHeader(2, 2)
		! # of output files
		nF = 2

		return

	end subroutine accretionDiscOutputFiles
!******************************************************************************

!******************************************************************************
	subroutine accretionDisc3DOutput()

		integer										::	i, j
		real(kind(1d0))								::	zF = 1d0

		! accretion disc 3D spatial coordinates
		open(unit = 1, file = trim(outpath)//'s3DDisc.out')
		call outputHeader(1, 2)
		! 3D spatial coordinates (using inner and outer disc)
		do j = 1, nAd, (nAd - 1)
			! loop for # of data points
			do i = 0, nDp, 6
				! write 3D spatial coordinates to file
				call outputEntry(1, 2, 0, xAd(j,i), yAd(j,i), -zF * hAd(j))
			end do
			if (IDL == 0) write(1, '(a1)') ''
			! loop for # of data points
			do i = 0, nDp, 6
				! write 3D spatial coordinates to file
				call outputEntry(1, 2, 0, xAd(j,i), yAd(j,i), zF * hAd(j))
			end do
			if (IDL == 0) write(1, '(a1)') ''
			zF = -zF
		end do
		! 'close' the disc...
		! loop for # of data points
		do i = 0, nDp, 6
			! write 3D spatial coordinates to file
			call outputEntry(1, 2, 0, xAd(1,i), yAd(1,i), -zF * hAd(1))
		end do
		if (IDL == 0) write(1, '(a1)') ''
		! close output file
		close(1)

		return

	end subroutine accretionDisc3DOutput
!******************************************************************************

!******************************************************************************
	subroutine accretionDiscReferencePoints()

		real(kind(1d0))								::	vK, Rs
		real(kind(1d0))								::	xRp, yRp, vxRp, vyRp
		integer										::	j

		! open output files
		call accretionDiscReferencePointsOutputFiles()
		! loop for # of references points
		do j = 1, 2
			! calculate reference points coordinates relative to primary
!			if (j == 1) xRp = 1.2 * sqrt(0.5 * (0.5 * rAd(nAd))**2)
!			if (j == 1) yRp = -sqrt((0.5 * rAd(nAd))**2 - xRp**2)
			if (j == 1) xRp = com
			if (j == 1) yRp = -sqrt((0.5 * rAd(nAd))**2 - xRp**2)
			if (j == 2) xRp = -rAd(nAd)
			if (j == 2) yRp = 0.
			! calculate polar spatial coordinates
			call polarCoords(xRp, yRp, theta, Rs)
			! calculate Keplerian velocity
			vK = sqrt(GC * M1 * MSun / (Rs * aa)) / vf
			! shift theta by 90 degrees (spatial vs velocity)
			theta = theta + PI / 2.
			! velocity coordinates
			vxRp = vK * cos(theta) * sini
			vyRp = vK * sin(theta) * sini + vCOM(1,y)
			! output accretion disc reference point coordinates
			call accretionDiscReferencePointOutput(xRp, yRp, vxRp, vyRp)
		end do
		! close output files
		call closeOutputFiles()

		return

	end subroutine accretionDiscReferencePoints
!******************************************************************************

!******************************************************************************
	subroutine accretionDiscReferencePointsOutputFiles()

		! accretion disc reference points velocity coordinates
		open(unit = 1, file = trim(outpath)//'vAB.out')
		call outputHeader(1, 1)
		! accretion disc reference points spatial coordinates
		open(unit = 2, file = trim(outpath)//'sAB.out')
		call outputHeader(2, 2)
		! # of output files
		nF = 2

		return

	end subroutine accretionDiscReferencePointsOutputFiles
!******************************************************************************

!******************************************************************************
	subroutine accretionDiscReferencePointOutput(xRp, yRp, vxRp, vyRp)

		real(kind(1d0)), intent(in)					::	xRp, yRp, vxRp, vyRp

		! output accretion disc reference point velocity and spatial coordinates
		! calculate polar velocity coordinates for disc radius
		call polarCoords(vxRp, vyRp, theta, v)
		! write velocity coordinates to file
		call outputEntry(1, 1, 1, vxRp, vyRp, 0d0, theta, 0d0, v)
		! write reference points spatial coordinates to file
		call outputEntry(2, 2, 1, xRp - com, yRp, 0d0)

		return

	end subroutine accretionDiscReferencePointOutput
!******************************************************************************

!******************************************************************************
	subroutine magneticStream()

		integer										::	i, j, nO, nM
		real(kind(1d0))								::	dFac, azRg

		if (mCV >= 1) then
			! default: above (nO = 1) orbital plane only
			nO = 1
			dFac = 1d0
			! for intermediate polars...
			if (mCV == 2) then
				! above and below (nO = 2) orbital plane
				nO = 2
				! calculate magnetosphere radius [binary separation]
				if (vDi > 0d0) then
					! ... inner disc radius [binary separation] (Eq 2.81 Warner 1995)
					rMag = (GC * M1 * MSun * sini**2 / (vDi * vf)**2) / aa
				else
					! ... 20% of outer disc radius [binary separation]
					rMag = 0.2d0 * rAd(nAd)
				end if
				! calculate Keplerian velocity at rMag
				vKMag = sqrt(GC * M1 * MSun / (rMag * aa)) / vf
!				write(*, '(3es14.6)') rAd(1), rMag, vKMag
!				call pause_here()
			end if
			! calculate magnetic dipole rotation and tilt matrix
			call magneticDipoleMatrix()
			! open output files
			call magneticStreamOutputFiles()
			! calculate # of magnetic dipole lines
			azRg = (azMe - azMs)
			if (azRg < 0d0) azRg = azRg + 360d0
			nM = int(azRg / azMi) + 1
			! loop for above and below orbital plane (if necessary)
			do i = 1, nO
				if (i == 2) then
					dFac = -1d0 * dFac
					! magnetic stream velocity coordinates
					close(3)
					open(unit = 3, file = trim(outpath)//'vStreamMag.1.out')
					call outputHeader(3, 1)
				end if
				! loop for # of magnetic dipole lines
				do j = 1, nM
					! calculate dipole connection point
					call magneticDipoleConnection(j)
					! calculate un-rotated, un-tilted dipole parameters
					call magneticDipoleParameters()
					! calculate spatial coordinates along rotated, tilted dipole line
					call magneticDipoleSpatialCoordinates(dFac)
					! calculate velocity coordinates along rotated, tilted dipole line
					call magneticDipoleVelocityCoordinates(dFac)
					! adjust x coordinates with assumed system com
					magnD(x,1:nDp) = magnD(x,1:nDp) - com
					! output dipole line velocity and spatial coordinates
					call magneticDipoleOutput(dFac)
				end do
			end do
			! close output files
			call closeOutputFiles()
			! calculate and output magnetic dipole 3d overlay
			call magneticDipole3D()
		end if

		return

	end subroutine magneticStream
!******************************************************************************

!******************************************************************************
	subroutine magneticDipoleMatrix()

		real(kind(1d0))								::	A0, B0
		integer										::	i, j, k

		! convert magnetic field axis angles to radians
		A0 = twoPI * Psi / 360.
		B0 = twoPI * beta / 360.
		! rotation matrix - rotate
		rotate(1,1) = cos(A0);	rotate(1,2) = -sin(A0);	rotate(1,3) = 0.
		rotate(2,1) = sin(A0);	rotate(2,2) = cos(A0);	rotate(2,3) = 0.
		rotate(3,1) = 0.;		rotate(3,2) = 0.;		rotate(3,3) = 1.
		! tilt matrix - tilt
		! tilt towards (+ beta) / away from (- beta) secondary
		tilt(1,1) = cos(B0);	tilt(1,2) = 0.;			tilt(1,3) = sin(B0)
		tilt(2,1) = 0.;			tilt(2,2) = 1.;			tilt(2,3) = 0.
		tilt(3,1) = -sin(B0);	tilt(3,2) = 0.;			tilt(3,3) = cos(B0)
		! rotate and tilt matrix - roTilt
		do i = 1, 3
			do j = 1, 3
				roTilt(i,j) = 0.	! for each roTilt(i,j)
				do k = 1, 3			! (row i of rotate) * (col j of tilt)
					roTilt(i,j) = roTilt(i,j) + rotate(i,k) * tilt(k,j)
				end do
			end do
		end do
!		do i = 1, 3 ! print row-by-row
!			write(*, '(3f11.6)') (roTilt(i, j), j = 1, 3)
!		end do

		return

	end subroutine magneticDipoleMatrix
!******************************************************************************

!******************************************************************************
	subroutine magneticStreamOutputFiles()

		! ballistic-magnetic stream connections velocity coordinates
		open(unit = 1, file = trim(outpath)//'vStreamBalConnect.out')
		call outputHeader(1, 1)
		! ballistic-magnetic stream connections velocity coordinates
		open(unit = 2, file = trim(outpath)//'vStreamMagConnect.out')
		call outputHeader(2, 1)
		! magnetic stream velocity coordinates
		open(unit = 3, file = trim(outpath)//'vStreamMag.out')
		call outputHeader(3, 1)
		! magnetic stream spatial coordinates
		open(unit = 4, file = trim(outpath)//'sStreamMag.out')
		call outputHeader(4, 2)
		! # of output files
		nF = 4

		return

	end subroutine magneticStreamOutputFiles
!******************************************************************************

!******************************************************************************
	subroutine magneticDipoleConnection(j)

		integer, intent(in)							::	j
		real(kind(1d0)) 							::	azDeg, azRad

		! initialise spatial and velocity coordinate arrays
		sMagnD = 0d0
		vMagnD = 0d0
		! azimuth angle where magnetic field line connects
		azDeg = azMs + (j - 1) * azMi
		if (azDeg > 360d0) azDeg = azDeg - 360d0
		! for polars...
		if (mCV == 1) then
			! interpolate spatial and velocity coordinates at this angle
			call interpolate1(nBa, azBs, xBs, azDeg, sMagnD(x,1))	! x-spatial
			call interpolate1(nBa, azBs, yBs, azDeg, sMagnD(y,1))	! y-spatial
			call interpolate1(nBa, azBs, vxBs, azDeg, vMagnD(x,1))	! x-velocity
			call interpolate1(nBa, azBs, vyBs, azDeg, vMagnD(y,1))	! y-velocity
		end if
		! for intermediate polars
		if (mCV == 2) then
			! upper curtain
			azRad = azDeg * PI / 180d0
			sMagnD(x,1) = rMag * cos(azRad)					! x-spatial
			sMagnD(y,1) = rMag * sin(azRad)					! y-spatial
			vMagnD(x,1) = vKMag * cos(azRad + 0.5d0 * PI)	! x-velocity
			vMagnD(y,1) = vKMag * sin(azRad + 0.5d0 * PI)	! y-velocity
		end if

		return

	end subroutine magneticDipoleConnection
!******************************************************************************

!******************************************************************************
	subroutine magneticDipoleParameters()

		real(kind(1d0)), dimension(3,3)				::	temp
		real(kind(1d0)), dimension(3,1)				::	sABC
		real(kind(1d0))								::	rU, phiU

		! initialise temporary arrays
		temp = roTilt
		sABC = sMagnD
		! assume connection is on a rotated and tilted field line, therefore
		! calculate un-rotated, un-tilted xyz spatial coordinates
		call gaussj(temp, 3, 3, sABC, 1, 1)
		! calculate un-rotated, un-tilted polar spatial coordinates
		! thetaU: un-rotated, un-tilted dipole azimuthal angle (xy-plane)
		! rU: un-rotated, un-tilted dipole radius (xy-plane)
		call polarCoords(sABC(x,1), sABC(y,1), thetaU, rU)
		! phiU: un-rotated, un-tilted dipole co-latitude angle (xz-plane)
		phiU = atan(abs(sABC(z,1)) / rU)
		! rE: un-rotated, un-tilted dipole equatorial radius
		rE = sqrt(sABC(x,1)**2 + sABC(y,1)**2 + sABC(z,1)**2) / cos(phiU)**2
		return

	end subroutine magneticDipoleParameters
!******************************************************************************

!******************************************************************************
	subroutine magneticDipoleSpatialCoordinates(dFac)

		real(kind(1d0)), intent(in)					::	dFac
		real(kind(1d0)), dimension(3,1)				::	sABC, sXYZ
		real(kind(1d0))								::	phiU, rU, azRad
		integer										::	i, j, k

		! initialise magnetic dipole line spatial and velocity coordinates array 
		magnD = 0d0
		! loop for # of data points
		do i = 1, nDp
			! calculate un-rotated, un-tilted dipole co-latitude angle (xz-plane)
!			phiU = 0.5 * PI * (1d0 - dFac + float(i) / float(nDp))
			phiU = PI * (-0.5d0 * dFac + float(i) / float(nDp))
			! calculate un-rotated, un-tilted dipole radius (xy-plane)
			rU = rE * cos(phiU)**2
			! calculate un-rotated, un-tilted spatial coordinates
			sABC(x,1) = rU * cos(phiU) * cos(thetaU)
			sABC(y,1) = rU * cos(phiU) * sin(thetaU)
			sABC(z,1) = rU * sin(phiU)
			! rotate and tilt spatial coordinates
			do j = 1, 3
				sXYZ(j,1) = 0.	! for each sXYZ(j,1)
				do k = 1, 3		! (row j of roTilt) * (col 1 of sABC)
					sXYZ(j,1) = sXYZ(j,1) + roTilt(j,k) * sABC(k,1)
				end do
				! write spatial coordinates to magnetic dipole line array
				magnD(j,i) = sXYZ(j,1)
			end do
		end do
		! update sMagnD and vMagnD array for lower curtain
		if (dFac == -1d0) then
			do i = 1, nDp
				if (dFac * magnD(z,i) >= 0.) then
					sMagnD(x,1) = magnD(x,i)				! x-spatial
					sMagnD(y,1) = magnD(y,i)				! y-spatial
					exit
				end if
			end do
			! determine azimuth
			call polarCoords(sMagnD(x,1), sMagnD(y,1), azRad, rU)
			vMagnD(x,1) = vKMag * cos(azRad + 0.5d0 * PI)	! x-velocity
			vMagnD(y,1) = vKMag * sin(azRad + 0.5d0 * PI)	! y-velocity
		end if

		return

	end subroutine magneticDipoleSpatialCoordinates
!******************************************************************************

!******************************************************************************
	subroutine magneticDipoleVelocityCoordinates(dFac)

		real(kind(1d0)), intent(in)					::	dFac
		real(kind(1d0)), dimension(0:3)				::	sXYZ0, sXYZ
		real(kind(1d0)), dimension(0:3)				::	vXYZ0, vXYZ
		real(kind(1d0)), dimension(0:3)				::	g0, g
		real(kind(1d0))								::	dX, dY, dZ
		real										::	dirX, dirY, dirZ
		real										::	thetaD, kappaD
		integer										::	i

		! initialise starting spatial coordinates
		sXYZ0(x) = sMagnD(x,1)
		sXYZ0(y) = sMagnD(y,1)
		sXYZ0(z) = sMagnD(z,1)
		sXYZ0(r) = sqrt(sXYZ0(x)**2 + sXYZ0(y)**2 + sXYZ0(z)**2)
		sXYZ = sXYZ0
		! initialise starting velocity coordinates
		vXYZ0(x) = vMagnD(x,1)
		vXYZ0(y) = vMagnD(y,1)
		vXYZ0(z) = vMagnD(z,1)
		vXYZ0(r) = sqrt(vXYZ0(x)**2 + vXYZ0(y)**2 + vXYZ0(z)**2)
		vXYZ = vXYZ0
		! calculate starting values - acceleration
		call magneticDipoleAcceleration(sXYZ0, g0)
		! calculate values along magnetic dipole line
		do i = 1, nDp
			! assume material follows 'positive' part (z>0) of dipole line,
			! i.e., dipole line with equatorial radius = rE...
			if (dFac * magnD(z,i) >= 0.) then
!			if (dFac * magnD(z,i) <= 0.) then
				! spatial coordinates
				sXYZ(x) = magnD(x,i)
				sXYZ(y) = magnD(y,i)
				sXYZ(z) = magnD(z,i)
				sXYZ(r) = sqrt(sXYZ(x)**2 + sXYZ(y)**2 + sXYZ(z)**2)
				! delta spatial coordinates
				dX = sXYZ(x) - sXYZ0(x)
				dY = sXYZ(y) - sXYZ0(y)
				dZ = sXYZ(z) - sXYZ0(z)
				! calculate acceleration
				call magneticDipoleAcceleration(sXYZ, g)
				! calculate velocity under assumption of conservation of energy
				vXYZ(r) = sqrt(vXYZ0(r)**2 + &
								2. * (g0(r) * sXYZ0(r) - g(r) * sXYZ(r)))
				! thetaD: angle in xy-plane
				thetaD = atan(abs(dY / dX))
				! kappaD: angle in xy-z plane ('bounce-off' angle)
				kappaD = atan(abs(dZ / sqrt(dX**2 + dY**2)))
				! calculate x, y and z directions
				dirX = 1.; dirY = 1.; dirZ = 1.
				if (dX /= 0.) dirX = dX / abs(dX)	! x-direction
				if (dY /= 0.) dirY = dY / abs(dY)	! y-direction
				if (dZ /= 0.) dirZ = dZ / abs(dZ)	! z-direction
				! split velocity in xyz-components
				vXYZ(x) = vXYZ(r) * cos(kappaD) * cos(thetaD) * dirX	! x-velocity
				vXYZ(y) = vXYZ(r) * cos(kappaD) * sin(thetaD) * dirY	! y-velocity
				vXYZ(z) = vXYZ(r) * sin(kappaD) * dirZ					! z-velocity
				! write velocity coordinates to magnetic dipole line array
				magnD(vx,i) = vXYZ(x)
				magnD(vy,i) = vXYZ(y)
				magnD(vz,i) = vXYZ(z)
				! update starting values
				sXYZ0 = sXYZ
				vXYZ0 = vXYZ
				g0 = g
			end if
		end do

		return

	end subroutine magneticDipoleVelocityCoordinates
!******************************************************************************

!******************************************************************************
	subroutine magneticDipoleAcceleration(sXYZ, g)

		real(kind(1d0)), dimension(0:3), intent(in)	::	sXYZ
		real(kind(1d0)), dimension(0:3), intent(out)	::	g
		real(kind(1d0))								::	thetag, rg
		real										::	phig

		! calculate azimuth angle
		call polarCoords(sXYZ(x), sXYZ(y), thetag, rg)
		! calculate polar angle
		phig = atan(sXYZ(z) / rg)
		! total acceleration in direction of primary
		g(r) = -1. / (sXYZ(r)**2)
		! split acceleration in xyz-components
		g(x) = g(r) * cos(phig) * cos(thetag)
		g(y) = g(r) * cos(phig) * sin(thetag)
		g(z) = g(r) * sin(phig)

		return

	end subroutine magneticDipoleAcceleration
!******************************************************************************

!******************************************************************************
	subroutine magneticDipoleOutput(dFac)

		real(kind(1d0)), intent(in)					::	dFac
		integer										::	i

		! set first flag
		first = 1
		! calculate polar velocity coordinates for dipole line connection
		call polarCoords(vMagnD(x,1), vMagnD(y,1), theta, v)
		! write velocity coordinates to file
		call outputEntry(1, 1, 0, vMagnD(x,1), vMagnD(y,1), 0d0, theta, 0d0, v)
		call outputEntry(2, 1, 0, vMagnD(x,1), vMagnD(y,1), 0d0, theta, 0d0, v)
		! loop for # of data points
		do i = 1, nDp
			! only 'positive' part (z>0) of dipole line
			if (dFac * magnD(z,i) >= 0.) then
!			if (dFac * magnD(z,i) <= 0.) then
				! calculate polar velocity coordinates for dipole line
				call polarCoords(magnD(vx,i), magnD(vy,i), theta, v)
				! write velocity coordinates to file
				if (first == 1) then
					call outputEntry(2, 1, 0, magnD(vx,i), magnD(vy,i), 0d0, theta, 0d0, v)
					first = 0
				end if
				call outputEntry(3, 1, 0, magnD(vx,i), magnD(vy,i), 0d0, theta, 0d0, v)
				! write dipole 3d spatial coordinates to file
				call outputEntry(4, 2, 0, magnD(x,i), magnD(y,i), magnD(z,i))
			end if
		end do
		if (IDL == 0) write(1, '(a1)') 'e'
		if (IDL == 0) write(2, '(a1)') 'e'
		if (IDL == 0) write(3, '(a1)') 'e'
		if (IDL == 0) write(4, '(a1)') ''

		return

	end subroutine magneticDipoleOutput
!******************************************************************************

!******************************************************************************
	subroutine magneticDipole3D()

		real(kind(1d0)), dimension(3,1)				::	sABC, sXYZ
		real(kind(1d0))								::	thetaD, phiD, rD
		integer										::	h, i, j, k, m, n

		! 3D magnetic dipole spatial coordinates
		open(unit = 1, file = trim(outpath)//'s3DDipole.out')
		call outputHeader(1, 2)
		! # of dipole lines
		m = 4	! m = 1,2,3,...
		! loop for # of dipole lines
		do n = 1, m
			do h = 0, 1
				! un-rotated, un-tilted dipole azimuthal angle
				thetaD = (n - 1) * PI / (2. * m) + h * 0.5 * PI
				! loop for # of data points
				do i = 0, nDp
					! un-rotated, un-tilted dipole co-latitude angle
					phiD = twoPI * float(i) / float(nDp)
					! calculate un-rotated, un-tilted dipole radius
					rD = rE * sin(phiD)**2
					! un-rotated, un-tilted spatial coordinates
					sABC(x,1) = rD * sin(phiD) * cos(thetaD)
					sABC(y,1) = rD * sin(phiD) * sin(thetaD)
					sABC(z,1) = rD * cos(phiD)
					! rotate and tilt
					do j = 1, 3
						sXYZ(j,1) = 0.	! for each sXYZ(j,1)
						do k = 1, 3		! (row j of roTilt) * (col 1 of sABC)
							sXYZ(j,1) = sXYZ(j,1) + roTilt(j,k) * sABC(k,1)
						end do
					end do
					! write dipole 3d spatial coordinates to file
					write(1, '(3es14.6)') sXYZ(x,1) - com, sXYZ(y,1), sXYZ(z,1)
				end do
				if (IDL == 0) write(1, '(a1)') 'e'
			end do
		end do
		close(1)

		return

	end subroutine magneticDipole3D
!******************************************************************************

!******************************************************************************
	subroutine keplerianTrace()

		real(kind(1d0))								::	xR0, xR, dxR, f, RR
		real(kind(1d0))								::	vxBc, vyBc, vxKc, vyKc
		integer										::	i, ix0, ix

		! velocity coordinates of Keplerian trace
		vxKt = vxKt * bvs * sini
		vyKt = (vyKt - comAdj) * bvs * sini
		! set starting values for Keplerian trace connections
		! starting radius (xBs(1) = RL1, i.e., radius at L1)
		xR = xBs(1)
		! delta radius
		dxR = 0.1
		ix = int(xR / dxR) + 1
		! open output files
		call keplerianTraceOutputFiles()
		! loop for # of points on ballistic stream
		do i = 1, nBa
			! output Keplerian trace velocity coordinates
			call keplerianTraceOutput(1, vxKt(i), vyKt(i))
			! save starting values for Keplerian trace connections
			xR0 = xR
			ix0 = ix
			! calculate radius at point on ballistic stream
			xR = sqrt(xBs(i)**2 + yBs(i)**2) / xBs(1)
			ix = int(xR / dxR)
!			if (abs(ix0 - ix) == 1) then
			if (ix0 - ix == 1) then
				RR = ix0 * dxR
				f = (ix0 * dxR - xR0) / (xR - xR0)
				! calculate ballistic stream connection velocity coordinates
				vxBc = f * vxBs(i) + (1 - f) * vxBs(i-1)
				vyBc = f * vyBs(i) + (1 - f) * vyBs(i-1)
				! output ballistic stream connection velocity coordinates
				call keplerianTraceOutput(2, vxBc, vyBc, RR)
				! calculate Keplerian trace connection velocity coordinates
				vxKc = f * vxKt(i) + (1 - f) * vxKt(i-1)
				vyKc = f * vyKt(i) + (1 - f) * vyKt(i-1)
				! output Keplerian trace connection velocity coordinates
				call keplerianTraceOutput(2, vxKc, vyKc)
			end if
		end do
		! close output files
		call closeOutputFiles()

		return

	end subroutine keplerianTrace
!******************************************************************************

!******************************************************************************
	subroutine keplerianTraceOutputFiles()

		! Keplerian trace velocity coordinates
		open(unit = 1, file = trim(outpath)//'vKeplerian.out')
		call outputHeader(1, 1)
		! Keplerian trace connections velocity coordinates
		open(unit = 2, file = trim(outpath)//'vKeplerianConnect.out')
		call outputHeader(2, 1)
		! # of output files
		nF = 2

		return

	end subroutine keplerianTraceOutputFiles
!******************************************************************************

!******************************************************************************
	subroutine keplerianTraceOutput(funit, vxK, vyK, RR)

		integer, intent(in)							::	funit
		real(kind(1d0)), intent(in)					::	vxK, vyK
		real(kind(1d0)), optional, intent(in)		::	RR

		! calculate polar velocity coordinates for ballistic stream
		call polarCoords(vxK, vyK, theta, v)
		! write velocity coordinates to file
		if (present(RR)) then
			write(funit, '(8es14.6)') vxK, vyK, 0., theta, 0., v, RR
		else
			write(funit, '(7es14.6)') vxK, vyK, 0., theta, 0., v
		end if

		return

	end subroutine keplerianTraceOutput
!******************************************************************************

!******************************************************************************
	subroutine calculateRL1()

		! L1 radius: distance from centre of primary to inner Lagrangian point
		real(kind(1d0))								::	rl, rn, f, fa

		if (abs(1 - qm) < 1e-4) then
			rn = 0.5
		else
			rl = 0
			rn = 1 - qm
	 		do while (abs(rl / rn - 1) > 1e-4)
				rl = rn
				f = qm / (1 - rl)**2 - 1 / rl**2 + (1 + qm) * rl - qm
				fa = 2 * qm / (1 - rl)**3 + 2 / rl**3 + (1 + qm)
				rn = rl - f / fa
			end do
		end if
		RL1 = rn

		return

	end subroutine calculateRL1
!******************************************************************************

!******************************************************************************
	subroutine velocityInfo()

		integer										::	i
		real(kind(1d0))								::	sd, vd

		! radius of the primary (Eq 2.82 Warner 1995 (Nauenberg 1972))
		R1 = 0.78 * 1.e+7 * sqrt((MCh / M1)**(2./3.) - (M1 / MCh)**(2./3.))
!		! distance from L1 to primary (Eq 2.4c Warner 1995 (Silber 1992))
!		RL1 = aa / (1.0015 + qm**0.4056)
		! maximum Keplerian velocity (at the surface of the primary)
		vKmax = sqrt(GC * M1 * MSun / R1) * sini
		! maximum free fall velocity from infinity to the surface of the primary
		vFFmax = sqrt(2. * GC * M1 * MSun * (1. / R1)) * sini
		! maximum free fall velocity from L1 to the surface of the primary
		vFFmaxL1 = sqrt(2. * GC * M1 * MSun * ((1. / R1) - (1. / (aa * RL1)))) * sini
		! calculate 'length' of ballistic stream
		sd = 0d0
		do i = 2, nBa
			sd = sd + sqrt((xBs(i) - xBs(i - 1))**2 + (yBs(i) - yBs(i - 1))**2)
			vd = sqrt(vxBs(i)**2 + vyBs(i)**2)
		end do

		! open general velocity information output file
		open(unit = 1, file = trim(outpath)//'vInfo.out')
!		write(1, 65) RL1 / aa, 'RL1: Eq 2.4c Warner 1995 (Silber 1992)'
		write(1, 65) RL1, 'RL1'
		write(1, 65) sd, 'length of ballistic stream'
		if (mCV == 0 .or. mCV == 2) then
			if (vDi > 0d0) write(1, 65) rAd(1), 'radius, inner disc: Eq 2.81 Warner 1995'
			if (qm <= 0.3) then
				! 3:1 resonance (Eq 3.39 Warner 1995 -- P = Porb / 3)
				write(1, 65) rAd(nAd), 'radius, outer disc: 3:1 resonance - Eq 3.39 Warner 1995'
			else
				! r(tidal), where r(tidal) = 0.6a / (1 + q) (Paczynski 1977)
				write(1, 65) rAd(nAd), 'radius, outer disc: r(tidal) - Paczynski 1977'
			end if
		end if
		write(1, 65) R1 / aa, 'radius, primary: Eq 2.82 Warner 1995 (Nauenberg 1972)'
		write(1,  *)
		write(1, 66) vd, 'velocity at ballistic stream end'
		write(1, 66) vDi, 'max inner disc velocity (radial)'
		write(1, 66) vKmax / vf, 'max Keplerian velocity'
		write(1, 66) vFFmaxL1 / vf, 'max free fall velocity from RL1'
		write(1, 66) vFFmax / vf, 'max free fall velocity from infinity'
		write(1, 66) vCOM(0,y), 'y velocity component of system centre of mass'
		write(1, 66) vCOM(1,y), 'y velocity component of primary centre of mass'
		write(1, 66) vCOM(2,y), 'y velocity component of secondary centre of mass'
		! close output file
		close(1)

65 		format (1x, f6.3, ' [a]: ', a)
66 		format (1x, f6.3, ' [10**3 km/s]: ', a)

		return

	end subroutine velocityInfo
!******************************************************************************

!******************************************************************************
	subroutine outputParameters()

		integer										::	i

		! open parameter output file (needed for plotting routines)
		open(unit = 1, file = trim(outpath)//'pBinary')
		! write parameter file
		write(1, '(''mCV  = '', i3)') mCV
		write(1, '(''M1   = '', f7.3)') M1
		write(1, '(''inc  = '', f6.2)') inc
		write(1, '(''qm   = '', f7.3)') qm
		write(1, '(''com  = '', f10.6)') com
		write(1, '(''Porb = '', f10.6)') Porb
		write(1, '(''Pspn = '', f10.6)') Pspin
		write(1, '(''azE  = '', f6.2)') azE
		write(1, '(''azMs = '', f6.2)') azMs
		write(1, '(''azMe = '', f6.2)') azMe
		write(1, '(''azMi = '', f6.2)') azMi
		write(1, '(''Psi  = '', f6.2)') Psi
		write(1, '(''beta = '', f6.2)') beta
		write(1, '(''R1   = '', f7.3)') R1 / aa
		close(1)

		return

	end subroutine outputParameters
!******************************************************************************

!******************************************************************************
	subroutine outputHeader(funit, ftype)

		integer, intent(in)	::	funit, ftype

		if (IDL == 0) then
			select case (ftype)
				case (1) ! velocity coordinates output file
					write(funit, '(a)') '# velocity: x y z theta phi v'
				case (2) ! spatial coordinates output file
					write(funit, '(a)') '# position: x y z'
			end select
		end if

		return

	end subroutine outputHeader
!******************************************************************************

!******************************************************************************
	subroutine outputEntry(funit, ftype, fe, fx, fy, fz, ft, fp, fv)

		integer, intent(in)							::	funit, ftype, fe
		real(kind(1d0)), intent(in)					::	fx, fy, fz
		real(kind(1d0)), optional, intent(in)		::	ft, fp, fv

		select case (ftype)
			case (1) ! velocity coordinates output entry
				write(funit, '(7es14.6)') fx, fy, fz, ft, fp, fv
			case (2) ! spatial coordinates output entry
				write(funit, '(3es14.6)') fx, fy, fz
		end select
		if (IDL == 0 .and. fe == 1) write(funit, '(a1)') 'e'

		return

	end subroutine outputEntry
!******************************************************************************

!******************************************************************************
	subroutine closeOutputFiles()

		integer										::	i

		do i = 1, nF
			close(i)
		end do

		return

	end subroutine closeOutputFiles
!******************************************************************************

!******************************************************************************
	end program pbinarymodel
!******************************************************************************

!******************************************************************************
!
!    mconstants.f95 (part of doptomog package v2.0)
!    Copyright (C) 2015  Enrico J. Kotze ejk@saao.ac.za
!
!    This program is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    This program is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with this program.  If not, see <http://www.gnu.org/licenses/>.
!
!******************************************************************************
module mconstants
!******************************************************************************

!******************************************************************************
	implicit none
	! GC = gravitational constant [m**3 kg**(-1) s**(-2) or N m**2 kg**(-2)]
	real(kind(1d0)), parameter	::	GC = 6.673e-11
	! MSun = solar mass [kg]
	real(kind(1d0)), parameter	::	MSun = 1.9891e+30
	! RSun = solar radius [m]
	real(kind(1d0)), parameter	::	RSun = 6.9551e+8
	! MCh = Chandrasekhar mass [MSun]
	real(kind(1d0)), parameter	::	MCh = 1.44
	! cSI = speed of light [m/s]
	real(kind(1d0)), parameter	::	cSI = 2.99792458e+8
	! cCGS = speed of light [cm/s]
	real(kind(1d0)), parameter	::	cCGS = 2.99792458e+10
	! PI = yumyum
	real(kind(1d0)), parameter	::	PI = acos(-1d0)
	real(kind(1d0)), parameter	::	twoPI = 2d0 * PI
	! vf = m to 10**3 km factor
	real(kind(1d0)), parameter	::	vf = 1.e+6
!******************************************************************************

!******************************************************************************
end module mconstants
!******************************************************************************

!******************************************************************************

!******************************************************************************
!
!    mspectra.f95 (part of doptomog package v2.0)
!    Copyright (C) 2015  Enrico J. Kotze ejk@saao.ac.za
!
!    This program is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    This program is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with this program.  If not, see <http://www.gnu.org/licenses/>.
!
!******************************************************************************
module mspectra
!******************************************************************************

!******************************************************************************
	! general data:
	! cwd = current working directory
	character(len=255)								::	cwd = ''
	! srcpath = path to source folder
	character(len=255)								::	srcpath = ''
	! inpath = input path (folder containing spectrum files)
	character(len=255)								::	inpath = ''
	! outpath = output path
	character(len=255)								::	outpath = ''
	! stype = spectra process indicator
	integer											::	stype = 0
	! ios = status returned for read statement
	integer											::	ios = 0
	! tab character
	character(len=1)								::	tab = char(9)
	! debug indicator
	logical											::	debug

	! parameter data:
	! parameters for spectra process
	integer, parameter								::	prepare = 0
	integer, parameter								::	extract = 1
	integer, parameter								::	trailed = 2

	! input data:
	! specList = name of file containing list of spectra
	character(len=20)								::	specList = ''
	! specDir = name of folder containing list of spectra and spectra files
	character(len=20)								::	specDir = ''
	! pmod = period fold indicator (0 = orbital, 1 = spin, 2 = extract spin)
	integer											::	pmod = 0
	! fcol = column nr of spectrum file name in spectra list
	integer											::	fcol = 0
	! pcol = column nr of phase value
	integer											::	pcol = 0
	! dcol = column nr of phase interval (0 if not present)
	integer											::	dcol = 0
	! wcol = column nr of wavelength in spectrum file
	integer											::	wcol = 0
	! scol = column nr of spectrum in spectrum file
	integer											::	scol = 0
	! dpha = fixed phase interval for the exposure times (0 if not relevant)
	real(kind(1d0))									::	dpha = 0d0
	! rebin = rebin spectra indicator (0 = no, 1 = yes)
	integer											::	rebin = 0
	! nbin = nr of bins for rebinning
	integer											::	nbin = 0
	! K1 = K1 velocity [m/s]
	real(kind(1d0))									::	K1 = 0d0
	! K1pho = K1 phase-offset [phase]
	real(kind(1d0))									::	K1pho = 0d0
	! gam = gamma velocity [m/s]
	real(kind(1d0))									::	gam = 0d0
	! w0 = rest wavelength of line [Angstroms]
	real(kind(1d0))									::	w0 = 0d0
	! cw = wavelength range around w0 to keep (0 to keep everything)
	real(kind(1d0))									::	cw = 0d0
	! dw = wavelength range around w0 (w0 - dw < w < w0 + dw)
	real(kind(1d0))									::	dw = 0d0
	! df1 = dw factor for inner range
	real(kind(1d0))									::	df1 = 0d0
	! df2 = dw factor for outer range
	real(kind(1d0))									::	df2 = 0d0
	! if abl=1, invert line (for absorption lines)
	integer											::	abl = 0
	! if atm=1, take out atmospheric absorption
	integer											::	atm = 0
	! nho = nr of half orbit spectra to extract
	integer											::	nho = 0
	
	! calculated data:
	! dpham = average phase interval
	real(kind(1d0))									::	dpham = 0d0
	! npe = nr of phase entries
	integer											::	npe = 0
	! npr = reduced nr of phase entries
	integer											::	npr = 0
	! nws = nr of wavelength and spectrum entries
	integer											::	nws = 0
	! nve = nr of velocity entries
	integer											::	nve = 0
	! mcol = maximum columns in specific file
	integer											::	mcol = 0
	integer											::	i0, i1, nwl
	real(kind(1d0))									::	w1, w2, v1, v2, vs
	real(kind(1d0))									::	ca1, ca2, cla

	! array data:
	character(len=80), dimension(:), allocatable	::	sfile
	character(len=80), dimension(:), allocatable	::	entries
	
	real(kind(1d0)), dimension(2) 					::	wr, wc1, wc2
	real(kind(1d0)), dimension(:), allocatable		::	phase, dphase, pIndexM
	real(kind(1d0)), dimension(:), allocatable		::	tphase, tdphase
	real(kind(1d0)), dimension(:), allocatable		::	wlj, wl1, wl, wp, vp, bl
	real(kind(1d0)), dimension(:), allocatable		::	indx, ind, iw
	real(kind(1d0)), dimension(:), allocatable		::	tra, trb, trbc, clev
	real(kind(1d0)), dimension(:), allocatable		::	specj, spec1
	real(kind(1d0)), dimension(:,:), allocatable	::	spec
	real(kind(1d0)), dimension(:,:), allocatable	::	trw, trwc, spout, tspout

!******************************************************************************

!******************************************************************************
contains
!******************************************************************************

!******************************************************************************


!******************************************************************************

!******************************************************************************
end module mspectra
!******************************************************************************

!******************************************************************************

!******************************************************************************
!
!    pdoptomog.f95 (part of doptomog package v2.0)
!    Copyright (C) 2015  Enrico J. Kotze ejk@saao.ac.za
!
!    This program is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    This program is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with this program.  If not, see <http://www.gnu.org/licenses/>.
!
!******************************************************************************
program pdoptomog
!******************************************************************************

!******************************************************************************
	use mconstants
	use mfunctions
	use mdoptomog
	implicit none
	
	integer											::	i
	character(len=255)								::	arg

	! current working directory
	call getcwd(cwd)

	! input parameters from command line 
	do i = 1, iargc()
		call getarg(i, arg)
		if (i == 1) read(arg, '(i2)') proj
		if (i == 2) read(arg, '(a)') srcpath
		! ... that's it for now...
	end do
	write (cproj, '(i1)') proj

	! input parameters from 'doptomog.in'
	call inputParameters()

	! input spectra from 'specextract.out'
	call inputSpectra()

	! validate input
	call inputValidate()

	! calculate velocity variables
	call velocityVariables()

	! do Doppler tomography - loop for nr of half phases if necessary
	do i = 0, nhp
		! determine phase extracted stuff
		call phaseExtract(i)

		! calculate projection matrix
		call projectionMatrix()

		! initialise some work variables and arrays
		call initialise()

		! add baseline flux to input spectra
		call baselineFlux()

		! normalise input spectra to constant wavelength-integrated flux
		call spectraNormalised(i)

		! unitise spectra flux values
		call spectraUnitised()

		! construct dopmap
		call dopmapConstructed(i)

		! write output
		call output()

		! calculate flux modulation per pixel (if applicable)
		if (nhp > 0 .and. i == nhp) call fluxModulation()

		! deallocate work arrays
		deallocate(P, indP, ninP, Pt, indPt, ninPt, Psum, indx, indy)
		deallocate(phasep, dphasep, phasebins, sin2piphi, cos2piphi, vplower)
		deallocate(psic, psib, psi0, psi, phip, phib, phiu, phi0, phi)
		deallocate(chi, dHdpsi, dSdpsi, dpsi0, dpsi, dphi0, dphi)
	end do

	! deallocate final work arrays
	deallocate(phase, dphase, vp, phii)

!******************************************************************************
contains
!******************************************************************************

!******************************************************************************

!******************************************************************************
	subroutine inputParameters()

		! read input parameters
		integer											::	i

		! input data file
		inpath = trim(srcpath)//'in/'
		open(unit = 1, file = trim(inpath)//'doptomog.in')
		! type of likelihood function (0 = log, 1 = rms)
		read(1, *) iH
		! spectra to be normalised to constant wavelength-integrated light?
		read(1, *) nrm
		! smearing width in default map
		read(1, *) nsw
		! max number of iterations
		read(1, *) nmi
		! print control
		read(1, *) pri
		! accuracy of FME iteration
		read(1, *) acc
		! baseline flux added to spectrum (fraction of average spectrum)
		read(1, *) bfa
		! minimum overall base level added before normalisation
		read(1, *) bfm
		! alpha variable for penalty function
		read(1, *) alf
		! central absorption parameters
		read(1, *) amp
		read(1, *) wid
		! nr of pixels (in one direction)
		read(1, *) np
		! nr of half-phase maps
		read(1, *, end = 5) nhp
	5	continue
		close(1)

		return

	end subroutine inputParameters
!******************************************************************************

!******************************************************************************
	subroutine inputSpectra()

		! read input spectra
		integer											::	i, j, n

		inpath = trim(srcpath)//'out/spectra/'
		open(unit = 1, file = trim(inpath)//'specextract.out')
		! period fold indicator (0 = orbital, 1 = spin)
		read(1, *) pmod
		! velocity scale (to convert to m/s), gamma velocity, rest wavelength, ...
		read(1, *) vs, gam, w0, abl, atm, src
		! nr of phase bins, nr of velocity points
		read(1, *) npb, nvp
		! total nr of velocity entries
		nvt = npb * nvp
		! allocate dimensions to work arrays
		allocate(phase(npb), dphase(npb), vp(nvp), phii(nvt), spec(npb,nvp))
		! centres of phase bins
		read(1, *) (phase(i), i = 1, npb)
		! width of phase bins
		read(1, *) (dphase(i), i = 1, npb)
		! velocity points
		read(1, *) (vp(i), i = 1, nvp)
		! convert to m/s
		vp = vp / vs
		vs = vs / vs
		! spectra flux values
		read(1, *) (phii(i), i = 1, nvt)
!		read(1, *) ((spec(i,j), i = 1, npb), j = 1, nvp)
		close(1)
		! phase index master array (maximum index = # of phase values)
		allocate(pIndexM(0:npb)); pIndexM = 0d0
		do i = 1, npb
			pIndexM(i) = dble(i)
			do j = 1, nvp
				n = i + (j - 1) * npb
				spec(i,j) = phii(n)
!				phii(n) = spec(i,j)
			end do
		end do

		return

	end subroutine inputSpectra
!******************************************************************************

!******************************************************************************
	subroutine inputValidate()

		! smearing width in default map
		if (nsw <= 0) nsw = 4
		! accuracy of FME iteration
		if (acc <= 0d0) acc = 3e-3
		! max no of iterations
		if (nmi <= 0) nmi = 100
		! alfa variable
		if (alf <= 0d0) &
			alf = 0.003 * (dble(np) / nvp)**2 * dble(min(npb, nvp)) / nvp
		! central absorption parameters
		if (wid == 0d0) wid = 2.5e5
		if (wid < 0d0) then
			wid = 1d0; amp = 0d0
		end if
		! write to log
		call outputLog(l0)

		return

	end subroutine inputValidate
!******************************************************************************

!******************************************************************************
	subroutine velocityVariables()

		! determine velocity variables
		! maximum absolute velocity
		vmax = max(abs(vp(1)), vp(nvp))
		! velocity bin width
		dv = 2d0 * vmax / (np - 1)
		! calculate velocity point width
		dvi = (vp(nvp) - vp(1)) / (nvp - 1)
		! "half" nr of pixels
		fv = 0.5d0 * np

		return

	end subroutine velocityVariables
!******************************************************************************

!******************************************************************************
	subroutine phaseExtract(p)

		integer, intent(in)								::	p
		integer, dimension(4)							::	ip
		integer											::	i, j, n, m

		call phaseIndices(p, ip)
		npm = ip(4) - ip(3) + ip(2) - ip(1)
		nvm = npm * nvp
		! allocate dimensions to working phase arrays
		allocate(phasep(npm), dphasep(npm), phip(nvm))
		n = 0
		if (ip(2) > 0) then
			do i = ip(1) + 1, ip(2)
				n = n + 1
				phasep(n) = phase(i)
				dphasep(n) = dphase(i)
				do j = 1, nvp
					m = n + (j - 1) * npm
					phip(m) = spec(i,j)
				end do
			end do
		end if
		do i = ip(3) + 1, ip(4)
			n = n + 1
			phasep(n) = phase(i)
			dphasep(n) = dphase(i)
			do j = 1, nvp
				m = n + (j - 1) * npm
				phip(m) = spec(i,j)
			end do
		end do

		return

	end subroutine phaseExtract
!******************************************************************************

!******************************************************************************
	subroutine projectionMatrix()

		! projection matrix
		real(kind(1d0))									::	vx, vy
		integer											::	i, j, ix, iy, ir

		! total nr of map points
		nmt = int(PI * (0.25 * np**2 - 0.335 * np + 0.09))
		! allocate dimensions to work arrays
		allocate(P(nvm,nmt), indP(nvm,nmt), ninP(nvm))
		allocate(Pt(nmt,nvm), indPt(nmt,nvm), ninPt(nmt))
		allocate(Psum(nmt), indx(nmt), indy(nmt))
		! initialise forward and backward projection matrices, as well as index
		! arrays: ninP, ninPt, indP, indPt, indx and indy
		P = fmin; Pt = fmin; ninP = 0; ninPt = 0; indP = 0; indPt = 0
		indx = 0; indy = 0; Psum = 0d0
		! reset pixel counter
		ir = 0
		! sin and cos tables for lower, centre and upper edges of phase bins
		call phaseTables()
		! lower edges of velocity bins
		call velocityBins()
		! loop through velocity space
		do ix = 1, np
			! x-velocity grid defined: min and max of vx = (-vmax, vmax)
			vx = dv * (ix - fv - 0.5d0)
			do iy = 1, np
				! y-velocity grid defined: min and max of vy = (-vmax, vmax)
				vy = dv * (iy - fv - 0.5d0)
				! use only points inside circle of radius (vmax + 0.1dv)
				if (vx**2 + vy**2 < (vmax + 0.1d0 * dv)**2) then
					! determine projection matrix entry
					call projectionMatrixEntry(ix, iy, ir, vx, vy)
				end if
			end do
		end do
		nm = ir
		call projectionMatrixNormalised()

		return

	end subroutine projectionMatrix
!******************************************************************************

!******************************************************************************
	subroutine initialise()

		! allocate dimensions to work arrays
		allocate(psic(nm,4), psib(nm), psi0(nm), psi(nm))
		allocate(phib(nvm), phiu(nvm), phi0(nvm), phi(nvm))
		allocate(chi(nm), dHdpsi(nm), dSdpsi(nm))
		allocate(dpsi0(nm), dpsi(nm), dphi0(nvm), dphi(nvm))
		! "change" maps
		psic = 0d0
		! baseline map
		psib = 0d0
		! starting and "working" maps
		psi0 = 0d0; psi = 0d0
		! delta maps
		dpsi0 = 0d0; dpsi = 0d0
		! H and S derivative maps
		dHdpsi = 0d0; dSdpsi = 0d0
		! default map
		chi = 0d0
		! starting and "working" spectra flux values
		phi0 = 0d0; phi = 0d0
		! delta spectra flux values
		dphi0 = 0d0; dphi = 0d0

		return

	end subroutine initialise
!******************************************************************************

!******************************************************************************
	subroutine baselineFlux()

		! calculate baseline flux to get a flat background level in dopmap:
		! phib is the data corresponding to a flat (circular) dopmap
		! psib is the corresponding flat dopmap
		integer											::	i, j, ix, iy, ip
		real(kind(1d0))									::	vx, vy, d0, bf

		! initialise baseline spectra flux values
		phib = 0d0
		! flat background
		psib = 1d0
		! produce spectrum (phib) from psib
		call projectForward(psib, phib)
		! calculate baseline flux to add, i.e., bfa * average of input spectra
		bf = bfa * sum(phii) / nvt
		! value at v = 0
		d0 = phib(npm * nvp / 2)
		! normalise phib
		phib = phib * bf / d0
		! normalise background map
		psib = psib * bf / d0
		! add baseline to phii
		do i = 1, nvm
			phip(i) = phip(i) + phib(i)
			if (phip(i) < bf / 3d0) phip(i) = 1e-5 * bf
		end do

		return

	end subroutine baselineFlux
!******************************************************************************

!******************************************************************************
	subroutine spectraNormalised(p)

		! normalise by a phase-dependent factor to make wavelength-integrated
		! light constant with phase
		integer, intent(in)								::	p
		real(kind(1d0)), dimension(npm)					::	phisum
		real(kind(1d0))									::	phimin, bs
		integer											::	i, j, n

		if (nrm == 1 .and. p == 0) then
			phisum = 0d0; bs = 0d0
			! get sum
			do i = 1, npm
				do j = 1, nvp
					n = i + (j - 1) * npm
					phisum(i) = phisum(i) + phip(n)
				end do
			end do
			phisum = npm * phisum / sum(phisum)
			! get minimum of phisum
			phimin = minval(phisum)
			! set an overall base level to be added before normalisation
			if (phimin < bfm) bs = bfm - phimin
			! normalise spectra
			do i = 1, npm
				if (phisum(i) /= 0d0) then
					do j = 1, nvp
						n = i + (j - 1) * npm
						phip(n) = phip(n) * (1d0 + bs) / (phisum(i) + bs)
					end do
				end if
			end do
			! update spec array
			do i = 1, npm
				do j = 1, nvp
					n = i + (j - 1) * npm
					spec(i,j) = phip(n)
				end do
			end do
		end if

		return

	end subroutine spectraNormalised
!******************************************************************************

!******************************************************************************
	subroutine spectraUnitised()

		! unitising spectra flux values
		integer											::	i, j, n

		! initialise unitising spectra flux values
		phiu = 1d0
		! override values for zero baseline
		do i = 1, npm
			do j = 1, nvp
				n = i + (j - 1) * npm
				if (phib(n) == 0d0) phiu(n) = 0d0
			end do
		end do
		! normalise to average = 1
		phiu = npm * phiu / sum(phiu)

		return

	end subroutine spectraUnitised
!******************************************************************************

!******************************************************************************
	subroutine dopmapConstructed(p)

		! process model with alfa = alf,
		! converged to accuracy acc with Lucy's fast ME scheme
		integer, intent(in)								::	p

		! initialise quality function values, convergence measure
		Q = 0d0; Q0 = 0d0; del = 1d0
		! initialise return code and iterations counter
		ierr = 0; ni = 0
		! initialise starting map: psi0
		psi0 = sum(phip) / nm
		! copy starting map into "working" map: psi
		psi = psi0
		! loop until converged or max nr iterations reached
		do while (del > acc .and. ni < nmi)
			ni = ni + 1
			! process iteration
			call fmeIteration(); if (ierr == 4) exit
		end do
		! reconstruct "working" spectra
		call projectForward(psi, phi)
		! validate nr of iterations
		if (ni >= nmi) ierr = ierr + 1	! not converged
		! write log - summaries
		call outputLog(l2, append=1)
		! update starting map and spectra
		psi0 = psi; phi0 = phi
		! "clean" central velocity bins (if applicable)
		call centralVelocityBins()
		! add half phase work arrays to total arrays (if applicable)
		call totalArrays(p)

		return

	end subroutine dopmapConstructed
!******************************************************************************

!******************************************************************************
	subroutine output()

		! write output
		real(kind(1d0)), dimension(np,np)				::	map, dmap
		integer											::	i, j, k

		outpath = trim(srcpath)//'out/doptomog/'
		open(unit = 1, file = trim(outpath)//'doptomog.'//cproj//trim(chp)//'.out')
		! max velocity, m to 10**3 km factor, nr of pixels,
		! period fold indicator, projection type
		write(1, '(es14.6, es10.2, i5, 2i3)') vmax, vf, np, pmod, proj
		! input spectra, array sizes
		write(1, '(i3, i6, 2i5, " input spectra ")') 1, nvm, npm, nvp
		! input spectra parameters
		write(1, '(2es10.2, f10.2, 2i3, a)') vs, gam, w0, abl, atm, &
			'  '//trim(src)
		! phase coordinates of input spectra
		write(1, '(1p6es14.6)') (twoPI * phasep(i), i = 1, npm)
		write(1, '(1p6es14.6)') (twoPI * dphasep(i), i = 1, npm)
		! velocity coordinates of input spectra
		write(1, '(1p6es14.6)') (vp(i), i = 1, nvp)
		! flux values of input spectra
		write(1, '(1p6es14.6)') (phip(i) - phib(i), i = 1, nvm)
		! reconstructed spectra
		write(1, '(i3, i6, " reconstructed spectra ")') 1, nvm
		! flux values of reconstructed spectra
		write(1, '(1p6es14.6)') (phi0(i) - phib(i), i = 1, nvm)
		! dopmap, array sizes
		write(1, '(i3, i6, i5," dopmap ")') 1, nm, np
		! dopmap parameters
		write(1, '(3i3, 4es10.3)') iH, nrm, nsw, alf, wid, amp, acc
		! unfold dopmap image: 1D to 2D
		map = 0d0
		do j = 1, nm
			map(indx(j),indy(j)) = psi0(j) - psib(j)
		end do
		! dopmap
		write(1, '(1p6es14.6)') ((map(i,j), j = 1, np), i = 1, np)
		! delta maps
		write(1, '(i3, " delta maps ")') 4
		do k = 1, 4
			! use dmap to unfold change maps: 1D to 2D
			dmap = 0d0
			do j = 1, nm
				dmap(indx(j),indy(j)) = psic(j,k)
			end do
			write(1, '(1p6es14.6)') ((dmap(i,j), j = 1, np), i = 1, np)
		end do
		! modulation maps
		write(1, '(i3, '' modulation maps '')') 0
		close(1)

		return

	end subroutine output
!******************************************************************************

!******************************************************************************
	subroutine fluxModulation()

		integer									::	i, j

		! allocate work arrays
		allocate(tphase(nhp), gs(nhp), fs(nhp))
		tphase = 0d0; gs = 0d0; fs = 0d0
		allocate(mamp(nm), mpha(nm), mavg(nm))
		mamp = 0d0; mpha = 0d0; mavg = 0d0

		! loop through flux modulation pixel map
		do j = 1, nm
			do i = 1, nhp
				tphase(i) = mod(0.25d0 + float(i - 1) / float(nhp), 1d0)
				gs(i) = mpix(j,i)
			end do
			! determine flux modulation fit
			call fluxModulationFit(j)
		end do

		! update flux modulation
		call fluxModulationUpdate()

		! output flux modulation
		call fluxModulationOutput()

		! deallocate work arrays
		deallocate(tphii, tphi0, tphase)
		deallocate(tpsi, tpsic, mpix)
		deallocate(gs, fs, mavg, mamp, mpha, mpham)

		return

	end subroutine fluxModulation
!******************************************************************************

!******************************************************************************
	subroutine fluxModulationFit(j)

		! determine data fit with multi-variate least squares
		integer, intent(in)						::	j
		integer									::	i
		real(kind(1d0)), dimension(0:2)			::	as

		! sine fitting:
		as = 0d0
		! calculate a0 - average
		as(0) = sum(gs) / float(nhp)
		! calculate f(i)
		do i = 1, nhp
			! calculate f(i)
			fs(i) = gs(i) - as(0)
			! calcualte a1 - sin(PHI(i)) coefficient
			as(1) = as(1) + fs(i) * sin(twoPI * tphase(i))
			! calcualte a2 - cos(PHI(i)) coefficient
			as(2) = as(2) + fs(i) * cos(twoPI * tphase(i))
		end do
		as(1) = 2d0 * as(1) / float(nhp)
		as(2) = 2d0 * as(2) / float(nhp)
		! calculate amplitude, phase-offset and average, and write to maps
		mamp(j) = sqrt(as(1)**2 + as(2)**2)
		mpha(j) = atan(-1d0 * as(2) / as(1)) / twoPI
		if (as(1) < 0d0) mpha(j) = mpha(j) + 0.5d0
		mavg(j) = as(0)

		return

	end subroutine fluxModulationFit
!******************************************************************************

!******************************************************************************
	subroutine fluxModulationUpdate()

		integer									::	j
		real(kind(1d0))							::	mintot, maxtot
		real(kind(1d0))							::	minavg, maxavg
		real(kind(1d0))							::	minamp, maxamp

		allocate(mpham(nm))
		mpham = 0d0
		! min and max values
		mintot = minval(tpsi); maxtot = maxval(tpsi)
		minamp = minval(mamp); maxamp = maxval(mamp)
		minavg = minval(mavg); maxavg = maxval(mavg)
		! phase of max flux: phase-offset + 0.25
		mpham = mpha + 0.25d0
		! loop through pixel modulation map
		do j = 1, nm
			! normalise total, amplitude and average maps between 0 and 1
			tpsi(j) = (tpsi(j) - mintot) / (maxtot - mintot)
			mamp(j) = (mamp(j) - minamp) / (maxamp - minamp)
			mavg(j) = (mavg(j) - minavg) / (maxavg - minavg)
		end do

		! average totalled spectra
		tphii = tphii / float(nhp)
		tphi0 = tphi0 / float(nhp)

		return

	end subroutine fluxModulationUpdate
!******************************************************************************

!******************************************************************************
	subroutine fluxModulationOutput()

		! write output
		real(kind(1d0)), dimension(np,np)				::	map, dmap, mmap
		integer											::	i, j, k

		open(unit = 1, file = trim(outpath)//'fluxmodmap.'//cproj//'.out')
		! max velocity, m to 10**3 km factor, nr of pixels,
		! period fold indicator, projection type
		write(1, '(es14.6, es10.2, i5, 2i3)') vmax, vf, np, pmod, proj
		! input spectra, array sizes
		write(1, '(i3, i6, 2i5, " input spectra ")') 1, nvt, npb, nvp
		! input spectra parameters
		write(1, '(2es10.2, f10.2, 2i3, a)') vs, gam, w0, abl, atm, &
			'  '//trim(src)
		! phase coordinates of input spectra
		write(1, '(1p6es14.6)') (twoPI * phase(i), i = 1, npb)
		write(1, '(1p6es14.6)') (twoPI * dphase(i), i = 1, npb)
		! velocity coordinates of input spectra
		write(1, '(1p6es14.6)') (vp(i), i = 1, nvp)
		! flux values of input spectra
		write(1, '(1p6es14.6)') (tphii(i), i = 1, nvt)
		! reconstructed spectra
		write(1, '(i3, i6, " reconstructed spectra ")') 1, nvt
		! flux values of reconstructed spectra
		write(1, '(1p6es14.6)') (tphi0(i), i = 1, nvt)
		! dopmap, array sizes
		write(1, '(i3, i6, i5," dopmap ")') 1, nm, np
		! dopmap parameters
		write(1, '(3i3, 4es10.3)') iH, nrm, nsw, alf, wid, amp, acc
		! unfold dopmap image: 1D to 2D
		map = 0d0
		do j = 1, nm
			map(indx(j),indy(j)) = tpsi(j)
		end do
		! dopmap
		write(1, '(1p6es14.6)') ((map(i,j), j = 1, np), i = 1, np)
		! delta maps
		write(1, '(i3, " delta maps ")') 4
		do k = 1, 4
			! use dmap to unfold change maps: 1D to 2D
			dmap = 0d0
			do j = 1, nm
				dmap(indx(j),indy(j)) = tpsic(j,k)
			end do
			write(1, '(1p6es14.6)') ((dmap(i,j), j = 1, np), i = 1, np)
		end do
		! modulation maps
		write(1, '(i3, '' modulation maps '')') 4
		! unfold modulation average map image: 1D to 2D
		mmap = 0d0
		do j = 1, nm
			mmap(indx(j),indy(j)) = mavg(j)
		end do
		! average map
		write(1, '(1p6es14.6)') ((mmap(i,j), j = 1, np), i = 1, np)
		! unfold modulation amplitude map image: 1D to 2D
		mmap = 0d0
		do j = 1, nm
			mmap(indx(j),indy(j)) = mamp(j)
		end do
		! amplitude map
		write(1, '(1p6es14.6)') ((mmap(i,j), j = 1, np), i = 1, np)
		! unfold modulation phase-offset map image: 1D to 2D
		mmap = 99.9d0
		do j = 1, nm
			mmap(indx(j),indy(j)) = mpha(j)
		end do
		! phase-offset map
		write(1, '(1p6es14.6)') ((mmap(i,j), j = 1, np), i = 1, np)
		! unfold modulation phase of max flux map image: 1D to 2D
		mmap = 99.9d0
		do j = 1, nm
			mmap(indx(j),indy(j)) = mpham(j)
		end do
		! phase of max flux map
		write(1, '(1p6es14.6)') ((mmap(i,j), j = 1, np), i = 1, np)
		close(1)

		return

	end subroutine fluxModulationOutput
!******************************************************************************

!******************************************************************************

!******************************************************************************

!******************************************************************************
	subroutine phaseIndices(p, ip)

		integer, intent(in)								::	p
		integer, dimension(4), intent(out)				::	ip
		real(kind(1d0)), dimension(0:4)					::	pIndex
		real(kind(1d0)), dimension(4)					::	pRange
		real(kind(1d0))									::	pStep
		character(len=10)								::	acf = ''
		character(len=20)								::	pphase = ''

		ip = 0; pRange = 0d0
		if (p == 0) then
			chp = ''
			ip(4) = npb
			write(pphase, '(f5.3, " - ", f5.3)') 0.0, 1.0
		else
			pStep = 1d0 / dble(nhp)
			! write output file chp (i.e., which half-phase)
			write(chp, '(i3)') p - 1
			chp = '.'//trim(adjustl(chp))
			! write halfphases output (if any) to 'halfphases.out'
			if (p == 1) acf = 'sequential'
			if (p > 1) acf = 'append'
			open(unit = 1, file = trim(outpath)//'halfphases.'//cproj//'.out', &
				access = trim(acf))
			if (p == 1) write(1, '(i3)') nhp
			! determine half phase range
			if (pStep * (p - 1) < 0.5d0) then
				pRange(3) = pStep * (p - 1)
				pRange(4) = pStep * (p - 1) + 0.5d0
				write(1, '(2f10.4)') pRange(3), pRange(4)
				write(pphase, '(f5.3, " - ", f5.3)') pRange(3), pRange(4)
			else
				pRange(2) = pStep * (p - 1) - 0.5d0
				pRange(3) = pStep * (p - 1)
				pRange(4) = 1d0
				write(1, '(2f10.4)') pRange(3), pRange(2)
				write(pphase, '(f5.3, " - ", f5.3)') pRange(3), pRange(2)
			end if
			close(1)
			! interpolate phase indices for specified half phase range
			call interpolate(phase, pIndexM, npb, pRange, pIndex, 4)
			ip(1) = int(pIndex(1))
			ip(2) = int(pIndex(2))
			ip(3) = int(pIndex(3))
			ip(4) = int(pIndex(4))
			if (ip(3) > 0 .and. ip(4) == 0) ip(4) = ip(4) + npb
		end if
		! write to log
		call outputLog(l0, append=1, pphase=pphase)

		return

	end subroutine phaseIndices
!******************************************************************************

!******************************************************************************
	subroutine phaseTables()

		! lower, centre and upper edges of phase bins, as well as
		! sin and cos tables for lower, centre and upper edges of phase bins
		integer											::	i

		! allocate dimensions to work arrays
		allocate(phasebins(npm,3), sin2piphi(npm,3), cos2piphi(npm,3))
		do i = 1, 3
			phasebins(1:npm,i) = twoPI * (phasep + dble(i - 2) * 0.5d0 * dphasep)
			! sin tables for lower, centre and upper edges of phase bins
			sin2piphi(1:npm,i) = sin(phasebins(1:npm,i))
			! cos tables for lower, centre and upper edges of phase bins
			cos2piphi(1:npm,i) = cos(phasebins(1:npm,i))
		end do

		return

	end subroutine phaseTables
!******************************************************************************

!******************************************************************************
	subroutine velocityBins()

		! calculate lower edges of velocity bins
		integer											::	i

		! allocate dimensions to work arrays
		allocate(vplower(-1:nvp+2))
		do i = 1, nvp - 1
			vplower(i+1) = 0.5d0 * (vp(i) + vp(i+1))
		end do
		vplower(1) = vp(1) - 0.5d0 * (vp(2) - vp(1))
		vplower(nvp+1) = vp(nvp) + 0.5d0 * (vp(nvp) - vp(nvp-1))
		vplower(0) = vplower(1) - (vplower(2) - vplower(1))
		vplower(-1) = -10d0 * vmax
		vplower(nvp+2) = 10d0 * vmax

		return

	end subroutine velocityBins
!******************************************************************************

!******************************************************************************
	subroutine projectionMatrixEntry(ix, iy, ir, vx, vy)

		integer, intent(in)								::	ix, iy
		integer, intent(out)							::	ir
		real(kind(1d0)), intent(in)						::	vx, vy
		real(kind(1d0))									::	vphi, v, vp0, vp1
		real(kind(1d0))									::	vpmin, vpmax
		integer											::	ip, iv, kmin, kmax

		! increase pixel count
		ir = ir + 1
		if (ir > nmt) call outputLog(l3, args='"ir > nmt: "', argi=(/ir, nmt/))
		! set xy indices
		indx(ir) = ix; indy(ir) = iy
		! calculate projection velocity
		! determine polar velocity coordinates
		call polarCoords(vx, vy, vphi, v)
		! if inside-out projection... inside-out polar velocity coordinates
		if (proj > 0) call inoutCoords(vmax, dv, v, v)
		! loop through phases
		do ip = 1, npm
			! calculate line-of-sight velocity at phase bin edges
			call losVelocity(ir, ip, vphi, v, vpmin, vpmax)
			! calculate indices of line-of-sight bins
			call losIndices(vpmin, vpmax, kmin, kmax)
			! loop between kmin and kmax
			do iv = kmin, kmax
				! calculate projection element
				call projectionElement(ir, ip, iv, vpmin, vpmax)
			end do
		end do

		return

	end subroutine projectionMatrixEntry
!******************************************************************************

!******************************************************************************
	subroutine losVelocity(ir, ip, vphi, v, vpmin, vpmax)

		! determine line-of-sight velocity at phase bin edges
		integer, intent(in)								::	ir, ip
		real(kind(1d0)), intent(in)						::	vphi, v
		real(kind(1d0)), intent(out)					::	vpmin, vpmax
		real(kind(1d0))									::	vp0, vp1, vpc

		vpc = v * sin(phasebins(ip,centre) - vphi)
		vp0 = v * sin(phasebins(ip,lower) - vphi)
		vp1 = v * sin(phasebins(ip,upper) - vphi)
		if (vp0 > vp1) then
			vpmin = vp1 - 0.5d0 * dv
			vpmax = vp0 + 0.5d0 * dv
		else
			vpmin = vp0 - 0.5d0 * dv
			vpmax = vp1 + 0.5d0 * dv
		end if
		if (vpmin < vplower(-1)) call outputLog(l3, &
									args='"vpmin < vplower(-1): "', &
									argr=(/vpmin, vplower(-1)/))
		if (vpmax > vplower(nvp+2)) call outputLog(l3, &
									args='"vpmax > vplower(nvp+2): "', &
									argr=(/vpmax, vplower(nvp+2)/))

		return

	end subroutine losVelocity
!******************************************************************************

!******************************************************************************
	subroutine losIndices(vpmin, vpmax, kmin, kmax)

		! determine indices of line-of-sight bins for vpmin and vpmax
		real(kind(1d0)), intent(in)						::	vpmin, vpmax
		integer, intent(out)							::	kmin, kmax

		kmin = (vpmin - vplower(1)) / dvi + 1
		kmax = (vpmax - vplower(1)) / dvi + 1
		kmin = max(0, kmin)
		kmin = min(kmin, nvp + 1)
		kmax = min(kmax, nvp + 1)
		kmax = max(0, kmax)
		! get first vplower(i) < vpmin
		if (vplower(kmin) < vpmin) then
			do while (vplower(kmin+1) < vpmin)
				kmin = kmin + 1
			end do
		else
			do while (vplower(kmin-1) > vpmin)
				kmin = kmin - 1
			end do
		end if
		! get first vplower(i) < vpmax
		if (vplower(kmax) < vpmax) then
			do while (vplower(kmax+1) < vpmax)
				kmax = kmax + 1
			end do
		else
			do while (vplower(kmax-1) > vpmax)
				kmax = kmax - 1
			end do
		end if
		kmin = max(1, kmin)
		kmax = min(kmax, nvp)

		return

	end subroutine losIndices
!******************************************************************************

!******************************************************************************
	subroutine projectionElement(ir, ip, iv, vpmin, vpmax)

		! calculate projection element
		integer, intent(in)								::	ir, ip, iv
		real(kind(1d0)), intent(in)						::	vpmin, vpmax
		real(kind(1d0))									::	x0, x1, w, vpa, vfa
		integer											::	inp, ict, icp

		! determine contribution factor
		x0 = (vplower(iv) - vpmin) / (vpmax - vpmin)
		x1 = (vplower(iv+1) - vpmin) / (vpmax - vpmin)
		w = dist(x1) - dist(x0)
		! apply central absorption fudge
		vpa = 0.5d0 * (vpmax + vpmin)
		vfa = 1d0 + amp * exp(-min((vpa / wid)**2, 50d0))
		w = w / vfa
		! compute index of this phase-velocity point in data array
		inp = ip + (iv - 1) * npm
		! up counter for P of number of hits in this bin
		icp = ninP(inp) + 1
		if (icp > nmt) call outputLog(l3, &
							args='"projection matrix too small, icp > nmt: "', &
							argi=(/icp, nmt/))
		ninP(inp) = icp
		! store matrix element and save reconstruction index
		P(inp,icp) = w
		indP(inp,icp) = ir
		! up counter for Pt of number of hits in this bin
		ict = ninPt(ir) + 1
		if (ict > nvm) call outputLog(l3, &
							args='"projection matrix too small, ict > nvm: "', &
							argi=(/ict, nvm/))
		ninPt(ir) = ict
		! store transpose element and save data index
		Pt(ir,ict) = w
		indPt(ir,ict) = inp
		! sum contribution factors
		Psum(ir) = Psum(ir) + P(inp,icp)

		return

	end subroutine projectionElement
!******************************************************************************

!******************************************************************************
	subroutine projectionMatrixNormalised()

		! normalise P, Pt
		integer											::	i, j, n, m

		do j = 1, nm
			n = ninPt(j)
			Pt(j,1:n) = Pt(j,1:n) / Psum(j)
		end do
		do i = 1, nvm
			m = ninP(i)
			do j = 1, m
				n = indP(i,j)
				P(i,j) = P(i,j) / Psum(n)
			end do
		end do

		return

	end subroutine projectionMatrixNormalised
!******************************************************************************

!******************************************************************************
	subroutine fmeIteration()

		! determine optimum direction and update factor from dpsi0 and dpsi
		! reconstruct "working" spectra
		call projectForward(psi, phi)
		! calculate quality function Q
		call qualityFunction()
		! new delta map: dpsi
		dpsi = psi * (dHdpsi + alf * dSdpsi); if (ni == 1) dpsi0 = dpsi
		! derivatives of Q w.r.t. to lambda and mu at current psi: fla, fmu
		call acceleration(); if (ierr == 4) return
		! calculate direction and update psi
		call accelerationApplied()
		! measure convergence
		call convergence()
		! write log
		call outputLog(l1, append=1)
		! re-normalise psi (mostly to strip accumulating numerical noise)
		psi = psi * sum(phip) / sum(psi)

		return

	end subroutine fmeIteration
!******************************************************************************

!******************************************************************************
	subroutine centralVelocityBins()

		! "clean" central velocity bins (if applicable)
		integer											::	j, k
		real(kind(1d0))									::	psimin

		if (proj > 0) then
			psimin = minval(psi0)
			k = np / 2
			do j = 1, nm
				if (indx(j) >= 1 - mc + k .and. indx(j) <= mc + k .and. &
				  indy(j) >= 1 - mc + k .and. indy(j) <= mc + k) then
				  	psi0(j) = psimin
				end if
			end do
		end if

		return

	end subroutine centralVelocityBins
!******************************************************************************

!******************************************************************************
	subroutine totalArrays(p)

		! add work arrays to output arrays
		integer, intent(in)						::	p
		integer									::	i, j, k, m, n

		if (p > 0) then
			! allocate dimension to total arrays
			if (p == 1) then
				allocate(tphii(nvt), tphi0(nvt)); tphii = 0d0; tphi0 = 0d0
				allocate(tpsi(nm), tpsic(nm,4)); tpsi = 0d0; tpsic = 0d0
				allocate(mpix(nm,nhp)); mpix = 0d0
			end if
			! spectra
			do k = 1, npb
				do i = 1, npm
					if (phase(k) == phasep(i)) then
						! total input and reconstructed spectra
						do j = 1, nvp
							m = k + (j - 1) * npb
							n = i + (j - 1) * npm
							tphii(m) = tphii(m) + (phip(n) - phib(n))
							tphi0(m) = tphi0(m) + (phi0(n) - phib(n))
						end do
					end if
				end do
			end do
			! maps
			do j = 1, nm
				! total dopmap
				tpsi(j) = tpsi(j) + (psi0(j) - psib(j))
				! delta dopmaps
				do k = 1, 4
					tpsic(j,k) = tpsic(j,k) + psic(j,k)
				end do
				! flux modulation pixel map
				if ((psi0(j) - psib(j)) /= 0d0) mpix(j,p) = psi0(j) - psib(j)
			end do
		end if

		return

	end subroutine totalArrays
!******************************************************************************

!******************************************************************************
	subroutine qualityFunction()

		! quality function Q
		! H and dH/dpsi
		call likelihood()
		! S and dS/dpsi
		call entropy()
		! save old value of Q
		Q0 = Q
		! current value of Q
		Q = H + alf * S
		! warning if not monotonic
		if (ni /= 1 .and. Q < Q0) ierr = 2

		return

	end subroutine qualityFunction
!******************************************************************************

!******************************************************************************
	subroutine likelihood()

		! likelihood part of quality function Q
		! likelihood function H and its derivative w.r.t. psi, dH/dpsi
		! dHdsp = delta-H spectra flux values
		real(kind(1d0)), dimension(nvm)					::	dHdphi
		integer											::	i

		H = 0d0
		dHdphi = 0d0
		if (iH == 0) then
			! log likelihood - H
			do i = 1, nvm
				if (phi(i) > 0d0) then
					! log likelihood - H
					H = H + phiu(i) * (phip(i) * log(phi(i)) - phi(i))
					! derivative w.r.t. to phi, dH/dphi
					dHdphi(i) = phiu(i) * (phip(i) / phi(i) - 1d0)
				end if
			end do
		else
			! rms likelihood - H
			H = nvm * sum(-1d0 * phiu * (phip - phi)**2)
			! derivative w.r.t. to phi, dH/dphi
			dHdphi = 2d0 * nvm * phiu * (phip - phi)
		end if
		! derivative w.r.t. to psi, dH/dpsi
		call projectBackward(dHdphi, dHdpsi)
		! delta-H (in same array as dHdpsi)
		dHdpsi = dHdpsi + (sum(phip) - sum(psi * dHdpsi)) / sum(psi) - 1d0

		return

	end subroutine likelihood
!******************************************************************************

!******************************************************************************
	subroutine entropy()

		! entropy part of quality function Q
		! entropy function S and its derivative w.r.t. psi, dS/dpsi
		! dpsi = (psi - chi) / chi
		real(kind(1d0)), dimension(nm) 					::	dpsi, dchi

		dpsi = 0d0; dchi = 0d0
		! get chi's
		call defaultMap(psi, chi)
		! entropy - S
		S = sum(psi - chi - psi * log(psi / chi))
		! derivative w.r.t. to psi, first the psi*log(psi) part
!		dSdpsi = -1d0 * log(psi / chi)
		dSdpsi = 1d0 - log(psi / chi)
		! add terms due to dependence of chi on psi
		dpsi = (psi - chi) / chi
		! get dchi's
		call defaultMap(dpsi, dchi)
		dSdpsi = dSdpsi + dchi
		! delta-S (in same array as dSdpsi)
		dSdpsi = dSdpsi - sum(psi * dSdpsi) / sum(psi)

		return

	end subroutine entropy
!******************************************************************************

!******************************************************************************
	subroutine acceleration()

		! calculate optimal acceleration variables lambda and mu from 1st and
		! 2nd derivatives of Q
		real(kind(1d0)), dimension(0:4)					::	dQ, dH, dS
		real(kind(1d0))									::	dd, dr

		! likelihood terms
		call accelerationLikelihoodTerms(dH)
		! entropy terms
		call accelerationEntropyTerms(dS)
		! quality function terms
		dQ = dH + alf * dS
		! calculate lambda and mu
		dd = dQ(dl2) * dQ(dm2) - dQ(dldm)**2
		dr = abs(dd) / (dQ(dl2)**2 + dQ(dm2)**2)
		! if det of 2x2 system too small, use only mu
		if (dr < 1e-3) then
			fla = 0d0
			fmu = -dQ(dm) / dQ(dm2)
		else
			fla = (dQ(dm) * dQ(dldm) - dQ(dl) * dQ(dm2)) / dd
			fmu = (dQ(dl) * dQ(dldm) - dQ(dm) * dQ(dl2)) / dd
		end if
		! additional acceleration multiplier mu: amu
		call accelerationAdditional()
		! check if amu has been small for awhile
		call accelerationCheck()

		return

	end subroutine acceleration
!******************************************************************************

!******************************************************************************
	subroutine accelerationLikelihoodTerms(dH)

		real(kind(1d0)), dimension(0:4), intent(out)	::	dH
		integer											::	i

		! get spectra from dpsi0, dpsi
		call projectForward(dpsi0, dphi0)
		call projectForward(dpsi, dphi)
		! first and second derivatives
		dH = 0d0
		if (iH == 0) then
			! log likelihood terms
			do i = 1, nvm
				if (phi(i) > 0d0) then
					dH(dl) = dH(dl) + dphi0(i) * phiu(i) * &
						(phip(i) / phi(i) - 1d0)
					dH(dm) = dH(dm) + dphi(i) * phiu(i) * &
						(phip(i) / phi(i) - 1d0)
					dH(dl2) = dH(dl2) - phiu(i) * phip(i) * &
						(dphi0(i) / phi(i))**2
					dH(dm2) = dH(dm2) - phiu(i) * phip(i) * &
						(dphi(i) / phi(i))**2
					dH(dldm) = dH(dldm) - phiu(i) * phip(i) * &
						(dphi0(i) / phi(i)) * (dphi(i) / phi(i))
				end if
			end do
		else
			! rms likelihood terms
			dH(dl) = nvm * sum(2d0 * phiu * (phip - phi) * dphi0)
			dH(dm) = nvm * sum(2d0 * phiu * (phip - phi) * dphi)
			dH(dl2) = nvm * sum(-2d0 * phiu * dphi0**2)
			dH(dm2) = nvm * sum(-2d0 * phiu * dphi**2)
			dH(dldm) = nvm * sum(-2d0 * phiu * dphi0 * dphi)
		end if

		return

	end subroutine accelerationLikelihoodTerms
!******************************************************************************

!******************************************************************************
	subroutine accelerationEntropyTerms(dS)

		real(kind(1d0)), dimension(0:4), intent(out)	::	dS
		real(kind(1d0)), dimension(0:4)					::	dt
		real(kind(1d0)), dimension(0:1)					::	dP
		real(kind(1d0)), dimension(nm)					::	dchi0, dchi
		real(kind(1d0))									::	Pj
		integer											::	j

		dchi0 = 0d0; dchi = 0d0
		! changes in chi corresponding to dpsi0, dpsi
		call defaultMap(dpsi0, dchi0)
		call defaultMap(dpsi, dchi)
		! first and second derivatives
		dt = 0d0; dP = 0d0; dS = 0d0
		! entropy terms
		do j = 1, nm
			dt(dl) = dchi0(j) / chi(j); dt(dm) = dchi(j) / chi(j)
			dt(dl2) = dt(dl)**2; dt(dm2) = dt(dm)**2; dt(dldm) = dt(dl) * dt(dm)
			dP(dl) = dpsi0(j) / psi(j); dP(dm) = dpsi(j) / psi(j)
			Pj = psi(j) - chi(j)
			dS(dl) = dS(dl) - dpsi0(j) * log(psi(j) / chi(j)) + Pj * dt(dl)
			dS(dm) = dS(dm) - dpsi(j) * log(psi(j) / chi(j)) + Pj * dt(dm)
			dS(dl2) = dS(dl2) - psi(j) * (dP(dl) - dt(dl))**2 + &
				Pj * (dt(dl)**2 - dt(dl2))
			dS(dm2) = dS(dm2) - psi(j) * (dP(dm) - dt(dm))**2 + &
				Pj * (dt(dm)**2 - dt(dm2))
			dS(dldm) = dS(dldm) - psi(j) * (dP(dl) - dt(dl)) * &
				(dP(dm) - dt(dm)) + Pj * (dt(dl) * dt(dm) - dt(dldm))
		end do

		return

	end subroutine accelerationEntropyTerms
!******************************************************************************

!******************************************************************************
	subroutine accelerationAdditional()

		! calculate additional multiplier mu
		real(kind(1d0))									::	lamu, flm
		integer											::	j

		lamu = 0d0; flm = 0d0
		! length of multiplier
		amu = sqrt(fla**2 + fmu**2)
		! direction (normalised) of optimum
		fla = fla / amu
		fmu = fmu / amu
		! determine limit for amu
		do j = 1, nm
			! value of prospective update
			lamu = fla * dpsi0(j) + fmu * dpsi(j)
			! if positivity not maintained at this value of lamu, get max limit
			if (lamu < 0d0 .and. -lamu / psi(j) > flm) flm = -lamu / psi(j)
		end do
		if (flm > 0d0) then
			! positivity restriction limits amu to safety factor 0.9
			flm = min(flim, 0.9d0 / flm)
		else
			! use overall max limit
			flm = flim
		end if
		! find max of amu
		amu = min(amu, flm)

		return

	end subroutine accelerationAdditional
!******************************************************************************

!******************************************************************************
	subroutine accelerationCheck()

		! set ierr = 4 if past 20 amu values were less than 0.01
		amus(mod(ni,20) + 1) = amu
		if (ni >= 20) then
			if (maxval(amus(1:20)) < 0.01d0) ierr = 4
		end if

		return

	end subroutine accelerationCheck
!******************************************************************************

!******************************************************************************
	subroutine accelerationApplied()

		integer											::	j

		! calculate direction and update psi
		do j = 1, nm
			! update previous delta psi (dpsi0) with direction
			dpsi0(j) = fla * dpsi0(j) + fmu * dpsi(j)
			! update map (psi)
			psi(j) = psi(j) + amu * dpsi0(j)
			! store change on total map
			psic(j,mod(ni,4)+1) = dHdpsi(j) + alf * dSdpsi(j)
		end do

		return

	end subroutine accelerationApplied
!******************************************************************************

!******************************************************************************
	subroutine convergence()

		real(kind(1d0))									::	del0
		integer											::	j

		del = 0d0
		! measure of convergence (Lucy's eq 17)
		do j = 1, nm
			del0 = abs(dHdpsi(j) + alf * dSdpsi(j)) / &
					(abs(dHdpsi(j)) + alf * abs(dSdpsi(j)))
			del = del + del0**2
		end do
		del = sqrt(del / nm)

		return

	end subroutine convergence
!******************************************************************************

!******************************************************************************
	subroutine defaultMap(psi, chi)

		! default map (chi) routine
		real(kind(1d0)), dimension(nm), intent(in)		::	psi
		real(kind(1d0)), dimension(nm), intent(out)		::	chi
		real(kind(1d0)), dimension(np,np)				::	x, y
		integer											::	j

		! initialise x and y
		x = 0d0; y = 0d0
		! unfold psi into x
		do j = 1, nm
			x(indx(j),indy(j)) = psi(j)
		end do
		call gaussianSmear(np, x, y)
		! fold y into chi
		do j = 1, nm
			chi(j) = y(indx(j),indy(j))
		end do

		return

	end subroutine defaultMap
!******************************************************************************

!******************************************************************************
	subroutine gaussianSmear(n, x, y)

		! gaussian smearing with half-width nsw, by consecutive 1-d smearing in
		! x and y
		integer, intent(in)								::	n
		real(kind(1d0)), dimension(n,n), intent(in)		::	x
		real(kind(1d0)), dimension(n,n), intent(out)	::	y
		real(kind(1d0)), dimension(-ms:n+ms)			::	t
		real(kind(1d0))									::	tsum
		integer											::	i, j, k

		! (re)make smearing matrix smp if value of nsw is new
		if (ns0 /= nsw) then
			call smearingMatrix()
		end if
		! smear in j-direction
		t = 0d0
		do i = 1, n
			! extend ith column of x into t
			do j = -ns1, 0
				! fold back
				t(j) = x(i,2-j-1)
			end do
			do j = 1, n
				t(j) = x(i,j)
			end do
			do j = n + 1, n + ns1
				t(j) = x(i,2*n-j+1)
			end do
			! smear t, result into y
			do j = 1, n
				tsum = 0d0
				do k = -ns1, ns1
					tsum = tsum + t(j+k) * smp(k)
				end do
				y(i,j) = tsum
			end do
		end do
		! smear in i-direction
		t = 0d0
		do j = 1, n
			! extend jth row of y into t
			do i = -ns1, 0
				! fold back
				t(i) = y(2-i-1,j)
			end do
			do i = 1, n
				t(i) = y(i,j)
			end do
			do i = n + 1, n + ns1
				t(i) = y(2*n-i+1,j)
			end do
			! smear t, result into y
			do i = 1, n
				tsum = 0d0
				do k = -ns1, ns1
					tsum = tsum + t(i+k) * smp(k)
				end do
				y(i,j) = tsum
			end do
		end do

		return

	end subroutine gaussianSmear
!******************************************************************************

!******************************************************************************
	subroutine smearingMatrix()

		! gaussian smearing matrix smp
		real(kind(1d0))									::	smpsum
		integer											::	i

		smpsum = 0d0
		! actual smearing width used is sw times 1st width nsw
		ns1 = int(sw * nsw)
		if (ns1 > ms) call outputLog(l3, args='"ns1 > ms: "', argi=(/ns1, ms/))
		ns0 = nsw
		do i = -ns1, ns1
			smp(i) = exp(-dble(i*i) / nsw**2)
			smpsum = smpsum + smp(i)
		end do
		! normalise
		do i = -ns1, ns1
			smp(i) = smp(i) / smpsum
		end do

		return

	end subroutine smearingMatrix
!******************************************************************************

!******************************************************************************
	subroutine projectForward(x, y)

		real(kind(1d0)), dimension(nm), intent(in)		::	x
		real(kind(1d0)), dimension(nvm), intent(out)	::	y
		integer											::	i, j, m, n

		y = 0d0
		do i = 1, nvm
			m = ninP(i)
			do j = 1, m
				n = indP(i,j)
				y(i) = y(i) + P(i,j) * x(n)
			end do
		end do

		return

	end subroutine projectForward
!******************************************************************************

!******************************************************************************
	subroutine projectBackward(y, x)

		real(kind(1d0)), dimension(nvm), intent(in)		::	y
		real(kind(1d0)), dimension(nm), intent(out)		::	x
		integer											::	i, j, m, n

		x = 0d0
		do j = 1, nm
			n = ninPt(j)
			do i = 1, n
				m = indPt(j,i)
				x(j) = x(j) + Pt(j,i) * y(m)
			end do
		end do

		return

	end subroutine projectBackward
!******************************************************************************

!******************************************************************************
	real function dist(x)

		real(kind(1d0)), intent(in)						::	x

		if (x < 0d0) then
			dist = 0d0
		else
			if (x < 0.5d0) then
				dist = 2d0 * x**2
			else
				if (x < 1d0) then
					dist = 1d0 - 2d0 * (1d0 - x)**2
				else
					dist = 1d0
				end if
			end if
		end if

		return

	end function dist
!******************************************************************************

!******************************************************************************
	subroutine outputLog(stage, append, pphase, args, argi, argr)

		integer, intent(in)								::	stage
		integer, optional, intent(in)					::	append
		character(*), optional, intent(in)				::	pphase, args
		integer, optional, dimension(2), intent(in)		::	argi
		real(kind(1d0)), optional, dimension(2), intent(in)	::	argr
		integer, dimension(2)							::	pru
		character(len=10)								::	acf
		character(len=40)								::	txt
		integer											::	i, iu, miu
		character(len=255)								::	logfile = ''

		acf = 'sequential'
		if (present(append) .and. append == 1) acf = 'append'
		pru(1) = 6; pru(2) = 10; miu = 2
		logfile = trim(srcpath)//'out/doptomog/doptomog.'//cproj//'.log'
		do i = pri + 1, miu
			iu = pru(i)
			if (i == miu) then
				open(unit = iu, file = trim(logfile), access = trim(acf))
			end if
			select case (stage)
			case (l0)
				! input summary
				if (present(append) .and. present(pphase)) then
					write(iu, '(a1)') ''
					write(iu, '(" - phase range      : ", a2, a)') '', pphase
					write(iu, '(a1)') ''
				else
					write(iu, '(" Fast maximum entropy, floating defaults")')
					if (proj == 0) txt = ' (standard projection)'
					if (proj == 1) txt = ' (inside-out projection)'
					write(iu, '(" proj               : ", i3, a)') proj, txt
					if (ih == 0) txt = ' (log likelihood)'
					if (ih == 1) txt = ' (rms likelihood)'
					write(iu, '(" iH                 : ", i3, a)') iH, txt
					write(iu, '(" nrm                : ", i3)') nrm
					write(iu, '(" nsw                : ", i3)') nsw
					write(iu, '(" nmi                : ", i5)') nmi
					write(iu, '(" acc                : ", es10.2)') acc
					write(iu, '(" alf                : ", es10.2)') alf
					write(iu, '(" amp                : ", es10.2)') amp
					write(iu, '(" wid                : ", es10.2)') wid
				end if
			case (l1)
				! line summary
				if (ni == 1) &
					write(iu, '("  it          Q=H+alfa*S      delta")')
				if (ni /= 1 .and. Q < Q0) then
					write(iu, '(i4, es20.12, es11.2, " **")') ni, Q, del
				else
					write(iu, '(i4, es20.12, es11.2)') ni, Q, del
				end if
			case (l2)
				write(iu, '(a1)') ''
				! iteration summary
				write(iu,'(" ni, alfa, Q:", i5, f8.4, es17.9)') ni, alf, Q
				! convergence summary
				if (ierr == 1) write(iu, '(" not converged")')
				if (ierr == 2) write(iu, '(" not monotonic")')
				if (ierr == 3) write(iu, '(" not converged, not monotonic")')
				if (ierr == 4) write(iu, '(" stuck at vanishing updates")')
				write(iu, '(a1)') ''
				! final summary
				write(iu, '(" entropy", es12.4)') S
				write(iu, '(a1)') ''
			case (l3)
				! errors
				if (present(args)) then
					if (present(argi)) write(iu, '('//args//', 2i5)') argi(1:2)
					if (present(argr)) write(iu, '('//args//', 2es12.4)') argr(1:2)
					if (i == miu) then
						close(iu)
						stop
					end if
				end if
			end select
			if (i == miu) close(iu)
		end do

		return

	end subroutine outputLog
!******************************************************************************

!******************************************************************************

!******************************************************************************
end program pdoptomog
!******************************************************************************

!******************************************************************************
!
!    mbinarymodel.f95 (part of doptomog package v2.0)
!    Copyright (C) 2015  Enrico J. Kotze ejk@saao.ac.za
!
!    This program is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    This program is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with this program.  If not, see <http://www.gnu.org/licenses/>.
!
!******************************************************************************
module mbinarymodel
!******************************************************************************

!******************************************************************************
	implicit none
!******************************************************************************

!******************************************************************************
	! general data:
	! cwd = current working directory
	character(len=255)				::	cwd = ''
	! srcpath = path to source folder
	character(len=255)				::	srcpath = ''
	! inpath = input path
	character(len=255)				::	inpath = ''
	! outpath = output path
	character(len=255)				::	outpath = ''
	! debug indicator
	logical							::	debug
	! IDL = IDL output indicator [0 = no, 1 = yes]
	integer							::	IDL
	! cmInd = centre of mass indicator [0 = use system com, 1 = use primary com]
	integer							::	cmInd
	
	! parameter data:
	! nDp = # of data points ...
	! nAd = # of accretion disc radii
	! nRl = # of points for Roche lobe arrays
	! nMax = max # of points for ballistic stream and Keplerian trace arrays
	integer, parameter	::	nDp = 360, nAd = 5, nRl = 720, nMax = 10000
	! eps = error margin for starting ballistic stream from L1
	! phaseMax = max phase for ballistic stream
	real(kind(1d0)), parameter	::	eps = 1e-3, phaseMax = 6d0
	! enumeration for sXYZ, vXYZ, magnD
	integer, parameter	::	r = 0, x = 1, y = 2, z = 3, vx = 4, vy = 5, vz = 6
	
	! input data: 'binarymodel.in'
	! mCV = magnetic cv indicator [0=no, 1=polar, 2=intermediate polar]
	integer							::	mCV
	! M1 = mass of primary in solar masses
	! qm = mass ratio M2/M1
	! inc = inclination angle of the system
	! Porb = orbital period of the system
	! Pspin = spin period of the primary
	! azE = azimuth angle at which ballistic stream ends
	real(kind(1d0))					::	M1, qm, inc, Porb, Pspin, azE
	! azMs = azimuth angle at which magnetic connection starts,
	! azMe = azimuth angle at which magnetic connection ends,
	! azMi = azimuth angle increment,
	! Psi = magnetic axis azimuth [towards(+)/away(-) secondary]
	! beta = magnetic axis co-latitude [towards(+)/away(-) secondary]
	real(kind(1d0))					::	azMs, azMe, azMi, Psi, beta
	! vDi = absolute velocity at inner disc [10**3 km/s]
	real(kind(1d0))					::	vDi

	! calculated data:
	integer											::	first
	! nF = # of output files
	! nBs = # of points for ballistic stream arrays
	! nBa = # of points for ballistic stream up to required azimuth
	integer											::	nF, nBs, nBa
	! thetaU: un-rotated, un-tilted dipole azimuthal angle (xy-plane)
	! rE = un-rotated, un-tilted dipole equatorial radius
	real(kind(1d0))									::	thetaU, rE
	! aa = binary separation
	! bvs = binary velocity scaling factor
	! sini = sin(i)
	! dv = delta velocity element
	real(kind(1d0))									::	aa, bvs, sini, dv
	! com = centre of mass
	! comSys = real centre of mass for system
	! comadj = velocity adjustment based on assumed velocity origin
	real(kind(1d0))									::	com, comSys, comAdj
	! R1 = radius of the primary
	! RL1 = distance from L1 to primary
	real(kind(1d0))									::	R1, RL1
	! vKmax = max Keplerian velocity
	! vFFmax = max free fall velocity from infinity
	! vFFmaxL1 = max free fall velocity from L1
	real(kind(1d0))									::	vKmax, vFFmax, vFFmaxL1
	! standard polar velocity coordinates
	real(kind(1d0))									::	theta, v
	! rMag = magnetosphere radius
	! vKMag = Keplerian velocity at rMag
	real(kind(1d0))									::	rMag, vKMag
	! rAd = accretion disc radii
	! hAd = accretion disc height at radii
	real(kind(1d0)), dimension(nAd)					::	rAd, hAd = 0.
	! theta360 = 360 degree array
	real(kind(1d0)), dimension(0:nDp)				::	theta360
	! xAd = x position of accretion disc radii
	! yAd = y position of accretion disc radii
	! vxAd = x velocity of accretion disc radii
	! vyAd = y velocity of accretion disc radii
	real(kind(1d0)), dimension(nAd, 0:nDp)			::	xAd, yAd, vxAd, vyAd
	! multi-dimensional arrays
	! rotate = rotate matrix
	! tilt = tilt matrix
	! roTilt = rotate and tilt matrix
	real(kind(1d0)), dimension(3,3)					::	rotate, tilt, roTilt
	! vCOM = centres of mass velocity coordinates
	! sCOM = centres of mass spatial coordinates
	real(kind(1d0)), dimension(0:2,2)				::	vCOM
	real(kind(1d0)), dimension(0:2,2)				::	sCOM
	! sMagnD = spatial coordinates of magnetic dipole connection
	! vMagnD = velocity coordinates of magnetic dipole connection
	real(kind(1d0)), dimension(3,1)					::	sMagnD, vMagnD
	! magnD = spatial and velocity coordinates of magnetic dipole line
	real(kind(1d0)), dimension(6,nDp)				::	magnD
	! allocatable 1-dimensional arrays
	! chi = polar angle array for the Roche lobes (from M1-direction)
	! phi = azimuth array for the Roche lobes (from orbital plane)
	real(kind(1d0)), allocatable, dimension(:)		::	chi, phi
	! xBs = x position of ballistic stream
	! yBs = y position of ballistic stream
	! vxBs = x velocity of ballistic stream
	! vyBs = y velocity of ballistic stream
	real(kind(1d0)), allocatable, dimension(:)		::	xBs, yBs, vxBs, vyBs
	! vxKt = x velocity of Keplerian trace
	! vyKt = y velocity of Keplerian trace
	real(kind(1d0)), allocatable, dimension(:)		::	vxKt, vyKt
	! azBs = ballistic stream azimuth from line M1-M2
	real(kind(1d0)), allocatable, dimension(:)		::	azBs
	! allocatable 2-dimensional arrays
	! rRl = radius array for the Roche lobes
	! xRl(1,n) = x position of primary's (M1) Roche lobe
	! yRl(1,n) = y position of primary's (M1) Roche lobe
	! xRl(2,n) = x position of secondary's (M2) Roche lobe
	! yRl(2,n) = y position of secondary's (M2) Roche lobe
	real(kind(1d0)), allocatable, dimension(:,:)	::	rRl, xRl, yRl

!******************************************************************************

!******************************************************************************
contains
!******************************************************************************

!******************************************************************************


!******************************************************************************

!******************************************************************************
end module mbinarymodel
!******************************************************************************

!******************************************************************************

!******************************************************************************
!
!    pspectra.f95 (part of doptomog package v2.0)
!    Copyright (C) 2015  Enrico J. Kotze ejk@saao.ac.za
!
!    This program is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    This program is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with this program.  If not, see <http://www.gnu.org/licenses/>.
!
!******************************************************************************
program pspectra
!******************************************************************************

!******************************************************************************
	use mconstants
	use mfunctions
	use mspectra
	implicit none
	
	integer											::	i
	character(len=255)								::	arg
	
	! get current working directory
	call getcwd(cwd)

	! get input parameters from command line 
	do i = 1, iargc()
		call getarg(i, arg)
		if (i == 1) read(arg, '(i2)') stype
		if (i == 2) read(arg, '(a)') srcpath
		! ... that's it for now...
	end do

	select case (stype)
		case (prepare)
			! get input from 'specprepare.in'
			call inputPrepare()
			! get input spectra
			call inputSpectraPrepare()
			! process spectra
			call processPrepare()
			! output spectra
			call outputPrepare()
		case (extract)
			! get input from 'specextract.in'
			call inputExtract()
			! get input spectra
			call inputSpectraExtract()
			! process spectra
			call processExtract()
			! output spectra
			call outputExtract()
	end select
	
!******************************************************************************
contains	
!******************************************************************************

!******************************************************************************

!******************************************************************************
	subroutine inputPrepare()

		! get input from 'specprepare.in'
		inpath = trim(srcpath)//'in/'
		open(unit = 1, file = trim(inpath)//'specprepare.in')
		! name of file containing list of spectra
		read(1, '(a20)') specList; specList = trim(specList)
		! name of folder containing list of spectra and spectra files
		read(1, '(a20)') specDir; specDir = trim(specDir)
		! period fold indicator (0 = orbital, 1 = spin, 2 = extract spin)
		read(1, *) pmod
		! column nr of spectrum file name in spectra list
		read(1, *) fcol
		! column nr of phase value
		read(1, *) pcol
		! column nr of phase interval (0 if not present)
		read(1, *) dcol
		! column nr of wavelength in spectrum file
		read(1, *) wcol
		! column nr of flux in spectrum file
		read(1, *) scol
		! fixed phase interval for the exposure times (0 if not relevant)
		read(1, *) dpha
	5	continue
		close(1)

		return

	end subroutine inputPrepare
!******************************************************************************

!******************************************************************************
	subroutine inputExtract()

		! get input from 'specextract.in'
		inpath = trim(srcpath)//'in/'
		open(unit = 1, file = trim(inpath)//'specextract.in')
		! gamma velocity [m/s]
		read(1, *) gam
		! rest wavelength of line [Angstroms]
		read(1, *) w0
		! wavelength range around w0 to keep (0 to keep everything)
		read(1, *) cw
		! wavelength range around w0 (w0 - dw < w < w0 + dw)
		read(1, *) dw
		! dw factor for inner range
		read(1, *) df1
		! dw factor for outer range
		read(1, *) df2
		! if abl = 1, invert line (for absorption lines)
		read(1, *) abl
		! if atm = 1, take out atmospheric absorption
		read(1, *) atm
		! nr of half orbit spectra to extract
		read(1, *, end = 5) nho
	5	continue
		close(1)

		return

	end subroutine inputExtract
!******************************************************************************

!******************************************************************************

!******************************************************************************
	subroutine inputSpectraPrepare()

		character(len=80)							::	line = ''
		integer										::	i, j

		! update 'inpath' with 'specDir'
		inpath = trim(inpath)//trim(specDir)//'/'

		! get number of lines in specList, i.e., nr of phases entries (npe)
		open(unit = 1, file = trim(inpath)//trim(specList))
		do
			read(1, *, iostat=ios) line
			if (ios /= 0) exit
			npe = npe + 1
		end do
		close(1)
		! allocate dimensions to applicable arrays
		allocate(sfile(npe), phase(npe), dphase(npe))
		phase = 0d0; dphase = 0d0; dpham = 0d0
		! set maximum number of columns to be read from specList
		mcol = max(fcol, pcol, dcol)
		! allocate dimensions to entries array
		allocate(entries(mcol))
		! process specList
		open(unit = 2, file = trim(inpath)//trim(specList))
		do i = 1, npe
			! read a line
			read(2, '(a)') line
			! read entries from the line
			read(line, *) (entries(j), j = 1, mcol)
			! get file name
			sfile(i) = trim(entries(fcol))
			! read phases into phase array
			read(entries(pcol), *) phase(i)
			! read phase intervals into dphase array (if present)
			if (dcol /= 0) read(entries(dcol), *) dphase(i)
			if (dcol /= 0) dpham = dpham + dphase(i)
		end do
		close(2)
		! determine phase intervals (if not present)
		if(dcol == 0) dphase = 1d0 / dble(npe)
		! determine average phase interval
		if(dcol /= 0) dpham = dpham / dble(npe)
		! if a fixed phase interval was specified
		if(dpha /= 0d0) dphase = dpha
		! determine average phase interval
		if(dpha /= 0d0) dpham = dpha
		! clean-up
		! de-allocate work arrays
		deallocate(entries)

		return

	end subroutine inputSpectraPrepare
!******************************************************************************

!******************************************************************************
	subroutine inputSpectraExtract()

		integer										::	i, j
		character(len=80)							::	errMessage

		inpath = trim(srcpath)//'out/spectra/'
		open(unit = 1, file = trim(inpath)//'specprepare.out')
		! read period fold indicator
		read(1, *) pmod
		! read array sizes
		read(1, *) npe, nws
		! allocate dimension to spec
		allocate(spec(npe, nws))
		! allocate dimension to phase, dphase, wl, wt
		allocate(phase(npe), dphase(npe), wl(nws)) !, wt(npe))
		! read phases and phase bins
		read(1, *) (phase(i), i = 1, npe)
		read(1, *) (dphase(i), i = 1, npe)
		! read wavelengths
		read(1, *) (wl(i), i = 1, nws)
		if ((w0 + dw) > wl(nws) .or. (w0 - dw) < wl(1)) then
			write(errMessage,'(a,f8.2,a,f6.2,a,2f8.2)') &
				'w0 =', w0, ' with dw =', dw, ' is out of range:', wl(1), wl(nws)
			call nrerror('inputSpectraExtract: '//trim(errMessage))
		end if
		if ((w0 + df2 * dw) > wl(nws) .or. (w0 - df2 * dw) < wl(1)) then
			write(errMessage,'(a,f8.2,a,f7.2,a,2f8.2)') &
				'w0 =', w0, ' with df2*dw =', df2 * dw, ' is out of range:', wl(1), wl(nws)
			call nrerror('inputSpectraExtract: '//trim(errMessage))
		end if
		! read spectra
		read(1, *) ((spec(i,j), i = 1, npe), j = 1, nws)
		! read file name containing list of spectra
		read(1, '(a20)') specList
		close(1)
		npr = npe
		! phase index master array (maximum index = # of phase values)
		allocate(pIndexM(0:npe))
		do i = 0, npe
			pIndexM(i) = dble(i)
		end do

		return

	end subroutine inputSpectraExtract
!******************************************************************************

!******************************************************************************
	subroutine processPrepare()

		character(len=80)							::	line = ''
		integer										::	i, j, k

		! set maximum number of columns to be read from each spectrum file
		mcol = max(wcol, scol)
		! allocate dimensions to entries arrays
		allocate(entries(mcol))
		do i = 1, npe
			nws = 0
			! get number of lines in spectrum file, i.e., nr of wavelength and
			! spectrum entries (nws)
			open(unit = 1, file = trim(inpath)//sfile(i))
			do
				read(1, *, iostat=ios) line
				if (ios /= 0) exit
				nws = nws + 1
			end do
			close(1)
			! allocate dimensions to applicable arrays
			if (i > 1) then
				deallocate(wlj, specj, spec1)
			end if
			allocate(wlj(nws), specj(0:nws), spec1(0:nws))
			specj = 0d0; spec1 = 0d0
			! read spectrum file
			open(unit = 2, file = trim(inpath)//sfile(i))
			do j = 1, nws
				! read a line
				read(2, '(a)') line
				! read entries from the line
				read(line, *) (entries(k), k = 1, mcol)
				! read wavelength into wlj array
				read(entries(wcol), *) wlj(j)
				! read spectrum into specj array
				read(entries(scol), *) specj(j)
			end do
			close(2)
			if (i == 1) then
				! allocate dimensions to applicable arrays
				allocate(wl1(nws), spec(npe,nws))
				! store first set of wavelengths
				wl1 = wlj
				spec1 = specj
			else
				! interpolate spectrum to scale of first file
				call interpolate(wlj, specj, nws, wl1, spec1, nws)
			end if
			! read spectrum into spec array
			do j = 1, nws
				spec(i,j) = spec1(j)
			end do
		end do
		allocate(wl(nws))
		wl = wl1
		! clean-up
		! de-allocate work arrays
		deallocate(entries, sfile, wlj, wl1, specj, spec1)

		return

	end subroutine processPrepare
!******************************************************************************

!******************************************************************************
	subroutine processExtract()

		! clean spectra
		call cleanSpectra()
		! sort phases
		call sortPhases()
		! convert to rest wavelength (gamma)
		call restWavelengthGamma()
		! determine windowed spectrum
		call windowedSpectrum()
		! remove atmospheric absorption
		call atmosphericAbsorption()
		! determine Doppler velocities
		call dopplerVelocities()
		! extract spectra
		call extractSpectra()
		! clean-up
		! de-allocate work arrays
		deallocate(bl, indx, ind, iw, trb, trbc, clev, trw, trwc)

		return

	end subroutine processExtract
!******************************************************************************

!******************************************************************************
	subroutine cleanSpectra()

		! clean spectra
		integer										::	i, j, nc
		real										::	sumc

		if(cw > 0.) then
			do i = 1, npe
				nc = 0
				sumc = 0.
				do j = 1, nws
					if(wl(j) < (w0 - cw) .or. wl(j) > (w0 + cw)) then
						nc = nc + 1
						sumc = sumc + spec(i,j)
					end if
				end do
				do j = 1, nws
					if(wl(j) < (w0 - cw) .or. wl(j) > (w0 + cw)) then
						spec(i,j) = sumc / nc
					end if
				end do
			end do
		end if

		return

	end subroutine cleanSpectra
!******************************************************************************

!******************************************************************************
	subroutine sortPhases()

		integer										::	i
		real, dimension(:), allocatable				::	phasef

		! sort phases
		allocate(phasef(npe))
		phasef = mod(phase, 1.)
		do i = 1, npe
			if (phasef(i) < 0.) phasef(i) = phasef(i) + 1.
		end do
		phase = phasef

		return

	end subroutine sortPhases
!******************************************************************************

!******************************************************************************
	subroutine restWavelengthGamma()

		! convert to rest wavelength (gamma)
		real(kind(1d0))								::	gamadj

		! subtract gamma velocity
		if (gam /= 0d0) then
			gamadj = (1d0 + gam / cSI) * sqrt(1d0 - (gam / cSI)**2)
			wl = wl / gamadj
			! apply relativity correction to spectra
			spec = spec * gamadj
		end if

		return

	end subroutine restWavelengthGamma
!******************************************************************************

!******************************************************************************
	subroutine windowedSpectrum()

		integer										::	i
		real										::	f
		real(kind(1d0)), dimension(:), allocatable	::	indt

		! allocate dimensions to index arrays
		allocate(indx(0:nws), iw(0:2)); indx = 0d0; iw = 0d0
		! master index array (maximum index = # of wavelength values)
		do i = 1, nws
			indx(i) = dble(i)
		end do
		! specified wavelengths
		wr(1) = w0 - df2 * dw
		wr(2) = w0 + df2 * dw
		! interpolate wavelength indices for specified wavelengths
		call interpolate(wl, indx, nws, wr, iw, 2)
		i0 = max(1, int(iw(1)))
		i1 = min(nws, int(iw(2)))
		! get the wavelengths between the indices
		wl = wl(i0:i1+1)
		nwl = (i1 + 1 - i0) + 1
		! allocate dimensions to windowed spectrum and other work arrays
		allocate(trw(npe,nwl), trwc(npe,nwl), trb(nwl), trbc(nwl), ind(nwl))
		allocate(clev(npe))
		! windowed spectrum
		trw = spec(1:npe,i0:i1+1)
		trwc = trw
		! phase averaged windowed spectrum
		trb = sum(trw, dim=1) / dble(npe)
		! corresponding wavelength index array (without zero index)
		ind = indx(1:nwl)
		! sort phase averaged windowed spectrum ascending
		call piksrt(nwl, trb, ind)
		! pick 25% of the indices around the median
		f = 0.25
		allocate(indt(int((1.-f)*0.5*(i1-i0))+1:int((1.+f)*0.5*(i1-i0))+1))
		indt = ind(int((1.-f)*0.5*(i1-i0))+1:int((1.+f)*0.5*(i1-i0))+1)
		clev = sum(trw(1:npe,int(indt)), dim=2) / dble(size(indt))
		! phase averaged
		cla = sum(clev) / dble(npe)
		deallocate(indt)

		return

	end subroutine windowedSpectrum
!******************************************************************************

!******************************************************************************
	subroutine atmosphericAbsorption()

		integer										::	i

		! remove atmospheric absorption
		if (atm == 1) then
			do i = 1, i1 - i0
				trw(1:npe,i) = trw(1:npe,i) / clev
			end do
			allocate(tra(nwl))
			tra = sum(trw, dim=1) / dble(npe)
			do i = 1, npe
				trw(i,1:nwl) = trw(i,1:nwl) - tra + 1d0
			end do
			do i = 1, i1 - i0
				trw(1:npe,i) = trw(1:npe,i) * clev
			end do
		end if
		do i = 1, npe
			trwc(i,1:nwl) = trw(i,1:nwl) - clev(i) + cla
		end do

		return

	end subroutine atmosphericAbsorption
!******************************************************************************

!******************************************************************************
	subroutine dopplerVelocities()

		integer										::	i, ic0, ic1, ic2, ic3

		! phase averaged windowed spectrum
		trbc = sum(trwc, dim=1) / dble(npe)
		! corresponding index array (with zero index)
		deallocate(ind); allocate(ind(0:nwl))
		ind = indx(0:nwl)
		! set wavelength ranges for continuum
		wc1(1) = w0 - df2 * dw
		wc1(2) = w0 - df1 * dw
		wc2(1) = w0 + df1 * dw
		wc2(2) = w0 + df2 * dw
		! interpolate wavelength indices for 1st range of continuum wavelengths
		call interpolate(wl, ind, nwl, wc1, iw, 2)
		ic0 = max(1, int(iw(1)))
		ic1 = min(nws, int(iw(2)))
		! interpolate wavelength indices for 2nd range of continuum wavelengths
		call interpolate(wl, ind, nwl, wc2, iw, 2)
		ic2 = max(1, int(iw(1)))
		ic3 = min(nws, int(iw(2)))
		! wavelength - average continuum
		ca1 = 0d0; ca2 = 0d0
		if (ic1 - ic0 /= 0d0) ca1 = sum(trbc(ic0:ic1-1)) / dble(ic1 - ic0)
		if (ic3 - ic2 /= 0d0) ca2 = sum(trbc(ic2:ic3-1)) / dble(ic3 - ic2)
		! average wavelength
		w1 = (wc1(1) + wc1(2)) / 2d0
		w2 = (wc2(1) + wc2(2)) / 2d0
		! Doppler velocity
		v1 = ((w1 / w0)**2 - 1d0) * cSI / ((w1 / w0)**2 + 1d0)
		v2 = ((w2 / w0)**2 - 1d0) * cSI / ((w2 / w0)**2 + 1d0)

		return

	end subroutine dopplerVelocities
!******************************************************************************

!******************************************************************************
	subroutine extractSpectra()

		integer										::	i

		! re-determine i0, i1:
		! specified wavelengths
		wr(1) = w0 - dw
		wr(2) = w0 + dw
		! interpolate wavelength indices for specified wavelengths
		call interpolate(wl, ind, nwl, wr, iw, 2)
		i0 = max(1, int(iw(1)))
		i1 = min(nws, int(iw(2)))
		! allocate dimension to spout
		nve = i1 - i0
		allocate(spout(npe,nve)); spout = 0d0
		allocate(wp(nve), vp(nve), bl(nve)); wp = 0d0; vp = 0d0; bl = 0d0
		wp = wl(i0+1:i1)
		! phase index array
		deallocate(ind); allocate(ind(1:npe))
		ind = indx(1:npe)
		! build spout
		do i = 1, npe
			spout(i,1:nve) = trwc(int(ind(i)),i0+1:i1)
		end do
		! calculate Doppler velocities for wavelengths in requested range
		vp = cSI * ((wl(i0+1:i1) / w0)**2 - 1d0) / ((wl(i0+1:i1) / w0)**2 + 1d0)
		! set velocity scale
		vs = 10.**(dble(int(dlog10(vp(nve))))) / vf
		! construct linearly varying continuum
		bl = (ca2 - ca1) / (v2 - v1) * (vp - v1) + ca1
		! subtract from spectrum
		do i = 1, npe
			spout(i,1:nve) = spout(i,1:nve) - bl
		end do
		if (abl /= 0) spout = -spout

		return

	end subroutine extractSpectra
!******************************************************************************

!******************************************************************************
	subroutine outputPrepare()

		integer										::	i, j

		! write output to 'specprepare.out'
		outpath = trim(srcpath)//'out/spectra/'
		open(unit = 1, file = trim(outpath)//'specprepare.out')
		write(1, '(i3)') pmod
		write(1, '(2i5)') npe, nws
		write(1, '(1p6es14.6)') phase(1:npe)
		write(1, '(1p6es14.6)') dphase(1:npe)
		write(1, '(1p6es14.6)') wl(1:nws)
		write(1, '(1p6es14.6)') ((spec(i,j), i = 1, npe), j = 1, nws)
		write(1, *) trim(specList)
		! clean-up
		! de-allocate work arrays
		deallocate(phase, dphase, wl, spec)

		return

	end subroutine outputPrepare
!******************************************************************************

!******************************************************************************
	subroutine outputExtract()

		integer										::	i, j, k, tpe
		character(len=4)							::	suffix

		outpath = trim(srcpath)//'out/spectra/'
		! allocate dimensions to temporary arrays
		allocate(tphase(npe), tdphase(npe), tspout(npe,nve))
		if (nho > 0) then
			! write phased output (if any) to 'specphased.out'
			open(unit = 1, file = trim(outpath)//'specphased.out')
			write(1, '(i3)') nho
		end if
		! loop for nr of half orbits
		do k = 0, nho
			! determine phase extracted stuff
			call phaseExtract(k, tpe, suffix)
			! write output to 'specextract.out'
			open(unit = 2, file = trim(outpath)//'specextract'//trim(suffix)//'.out')
			write(2, '(i3, es10.2)') pmod, vf
			write(2, '(2es10.2, f10.2, 2i3, a)') vs, gam, w0, abl, atm, '  '//trim(specList)
			write(2, '(2i5)') tpe, nve
			write(2, '(1p6es14.6)') (tphase(i), i = 1, tpe)
			write(2, '(1p6es14.6)') (tdphase(i), i = 1, tpe)
			write(2, '(1p6es14.6)') (vp(j), j = 1, nve)
			do j = 1, nve
				write(2, '(1p6es14.6)') tspout(1:tpe,j)
			end do
			close(2)
		end do
		if (nho > 0) then
			close(1)
		end if
		! clean-up
		! de-allocate work arrays
		deallocate(phase, dphase, vp, spout, tphase, tdphase, tspout, wl, spec)

	68 	format (a, a)
	69 	format (a, 'integer, parameter	::	', a, i3)

		return

	end subroutine outputExtract
!******************************************************************************

!******************************************************************************
	subroutine phaseExtract(k, tpe, suffix)

		integer, intent(in)							::	k
		integer, intent(out)						::	tpe
		character(len=4), intent(out)				::	suffix
		real(kind(1d0)), dimension(0:4)				::	pIndex
		real(kind(1d0)), dimension(4)				::	pRange
		real(kind(1d0))								::	pStep
		integer, dimension(4)						::	ip
		integer										::	i, j, n

		if (k == 0) then
			suffix = ''
			ip(1) = 0
			ip(2) = 0
			ip(3) = 0
			ip(4) = npe
		else if (k > 0) then
			pStep = 1d0 / dble(nho)
			! write output file suffix
			write(suffix, '(i3)') k - 1
			suffix = '.'//trim(adjustl(suffix))
			! determine half orbit range
			if (pStep * (k - 1) < 0.5d0) then
				pRange(1) = 0d0
				pRange(2) = 0d0
				pRange(3) = pStep * (k - 1)
				pRange(4) = pStep * (k - 1) + 0.5d0
				write(1, '(2f10.4)') pRange(3), pRange(4)
			else
				pRange(1) = 0d0
				pRange(2) = pStep * (k - 1) - 0.5d0
				pRange(3) = pStep * (k - 1)
				pRange(4) = 1d0
				write(1, '(2f10.4)') pRange(3), pRange(2)
			end if
			! interpolate phase indices for specified half orbit range
			call interpolate(phase, pIndexM, npe, pRange, pIndex, 4)
			ip(1) = int(pIndex(1))
			ip(2) = int(pIndex(2))
			ip(3) = int(pIndex(3))
			ip(4) = int(pIndex(4))
			if (ip(3) > 0 .and. ip(4) == 0) ip(4) = ip(4) + npe
		end if
		tpe = ip(4) - ip(3) + ip(2) - ip(1)
		n = 0
		if (ip(2) > 0) then
			do i = ip(1) + 1, ip(2)
				n = n + 1
				tphase(n) = phase(i)
				tdphase(n) = dphase(i)
				tspout(n,1:nve) = spout(i,1:nve)
			end do
		end if
		do i = ip(3) + 1, ip(4)
			n = n + 1
			tphase(n) = phase(i)
			tdphase(n) = dphase(i)
			tspout(n,1:nve) = spout(i,1:nve)
		end do

		return

	end subroutine phaseExtract
!******************************************************************************

!******************************************************************************

!******************************************************************************
end program pspectra
!******************************************************************************

!******************************************************************************
!
!    mdoptomog.f95 (part of doptomog package v2.0)
!    Copyright (C) 2015  Enrico J. Kotze ejk@saao.ac.za
!
!    This program is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    This program is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with this program.  If not, see <http://www.gnu.org/licenses/>.
!
!******************************************************************************
module mdoptomog
!******************************************************************************

!******************************************************************************
	implicit none
!******************************************************************************

!******************************************************************************
	! general data:
	! cwd = current working directory
	character(len=255)								::	cwd = ''
	! proj = projection (0 = std, 1 = inside-out), default = 0
	integer											::	proj = 0
	character(len=1)								::	cproj = ''
	! srcpath = path to source folder
	character(len=255)								::	srcpath = ''
	! inpath = input path
	character(len=255)								::	inpath = ''
	! outpath = output path
	character(len=255)								::	outpath = ''
	! debug indicator
	logical											::	debug
	
	! parameter data:
	integer, parameter				::	mc = 1
	! gaussian smearing parameters
	integer, parameter				::	ms = 100
	real, parameter					::	sw = 1.5
	! flim = max limit for acceleration parameter amu
	real(kind(1d0)), parameter		::	flim = 1e+5
	real(kind(1d0)), parameter		::	fmin = 1e-6
	! parameters for acceleration calculation
	integer, parameter	::	dl = 0, dm = 1, dl2 = 2, dm2 = 3, dldm = 4
	! parameters for stages at which output log is written
	integer, parameter				::	l0 = 0, l1 = 1, l2 = 2, l3 = 3
	! parameters for sine and cosine tables
	integer, parameter				::	lower = 1, centre = 2, upper = 3
	
	! input data: 'doptomog.in'
	! iH = type of likelihood function (0 = log, 1 = rms)
	! nrm = 1 for normalisation to flat light curve
	! nsw = smearing width in default map
	integer											::	iH, nrm, nsw
	! nmi = max number of iterations
	! pri = print control (0 = log and screen, 1 = log only)
	integer											::	nmi, pri
	! acc = accuracy of convergence
	! bfa = baseline flux factor (fraction of average spectrum)
	! bfm = minimum overall base level added before normalisation
	real(kind(1d0))									::	acc, bfa, bfm
	! alf = model alfa value
	! amp, wid = amplitude and width of central absorption fudge
	real(kind(1d0))									::	alf, amp, wid
	! np = nr of pixels (in one direction)
	! nhp = nr of half-phase maps
	integer											::	np, nhp = 0
	
	! input data: specFile
	! pmod = period fold indicator (0 = orbital, 1 = spin)
	! npb = nr of phase bins
	! nvp = nr of velocity points
	integer											::	pmod, npb, nvp
	! vs = velocity scale (factor to convert velocity points to m/s)
	! gam = gamma velocity (m/s)
	! w0 = line rest wavelength
	real(kind(1d0))									::	vs, gam, w0
	! if abl=1, invert line (for absorption lines)
	integer											::	abl
	! if atm=1, take out atmospheric absorption
	integer											::	atm
	! src (specList)
	character(len=20)								::	src = ''

	! array data:
	! vp = velocity points
	! phase = centres of phase bins
	! dphase = width of phase bins
	! phii = input spectra flux values
	real(kind(1d0)), dimension(:), allocatable		::	vp, phase, dphase, phii
	real(kind(1d0)), dimension(:,:), allocatable	::	spec

	! calculated data:
	! suffix = suffix to output files
	character(len=4)								::	chp = ''
	! phasep = centres of phase bins used
	! dphasep = width of phase bins used
	! phip = input spectra flux values used
	real(kind(1d0)), dimension(:), allocatable		::	phasep, dphasep, phip
	real(kind(1d0)), dimension(:), allocatable		::	pIndexM
	real(kind(1d0)), dimension(:,:), allocatable	::	specp
	! nvt = total nr of velocity entries
	! nmt = total nr of map points
	! nm = length of map solution
	! npm = nr of phase bins used
	! nvm = nr of velocity points used
	integer											::	nvt, nmt, nm, npm, nvm
	! vmax = maximum absolute velocity
	! fv = half of np
	! dv = velocity bin width
	! dvi = velocity point width
	real(kind(1d0))									::	vmax, fv, dv, dvi
	! H = calculated likelihood value
	! S = calculated entropy value
	! Q = calculated quality function
	! Q0 = previous quality function value
	! del = convergence measure
	real(kind(1d0))									::	H, S, Q, Q0, del
	! fla = lambda acceleration factor
	! fmu = mu acceleration factor
	! amu = additional acceleration factor
	real(kind(1d0))									::	fla, fmu, amu
	real(kind(1d0)), dimension(30)					::	amus
	! ns0, ns1 = interim values of ns
	integer											::	ns0 = 0, ns1 = 0
	! mi = number of modulation iterations
	! ni = number of fme iterations counter
	integer											::	mi, ni
	! idnr = identification number
	real(kind(1d0))									::	idnr
	
	! smp = smearing matrix
	real(kind(1d0)), dimension(-ms:ms)				::	smp

	! forward and backward projection matrices
	real(kind(1d0)), dimension(:,:), allocatable	::	P, indP
	real(kind(1d0)), dimension(:,:), allocatable	::	Pt, indPt
	! array for storage of sums of projection matrix
	real(kind(1d0)), dimension(:), allocatable		::	Psum
	! index arrays - projection matrices
	integer, dimension(:), allocatable				::	ninP
	integer, dimension(:), allocatable				::	ninPt
	! index arrays - image
	integer, dimension(:), allocatable				::	indx, indy
	! lower, centre and upper edges of phase bins
	real(kind(1d0)), dimension(:,:), allocatable	::	phasebins
	! sin and cos tables for centre, lower and upper edges of phase bins
	real(kind(1d0)), dimension(:,:), allocatable	::	sin2piphi, cos2piphi
	! lower edges of velocity bins
	real(kind(1d0)), dimension(:), allocatable		::	vplower

	! phib = baseline spectra flux values
	! phiu = unitising spectra flux values
	real(kind(1d0)), dimension(:), allocatable		::	phib, phiu
	! phi0 = starting spectra flux values
	! phi = "working" spectra flux values
	real(kind(1d0)), dimension(:), allocatable		::	phi0, phi
	! dphi0 = previous delta spectra flux values
	! dphi = current delta spectra flux values
	real(kind(1d0)), dimension(:), allocatable		::	dphi0, dphi
	! psib = flat dopmap corresponding to phib
	real(kind(1d0)), dimension(:), allocatable		::	psib
	! psi0 = starting dopmap
	! psi = "working" dopmap
	real(kind(1d0)), dimension(:), allocatable		::	psi0, psi
	! dpsi0 = previous delta dopmap
	! dpsi = current delta dopmap
	real(kind(1d0)), dimension(:), allocatable		::	dpsi0, dpsi
	! dHdpsi = likelihood derivative dopmap (dH/dpsi)
	! dSdpsi = entropy derivative dopmap (dS/dpsi)
	real(kind(1d0)), dimension(:), allocatable		::	dHdpsi, dSdpsi
	! psic = change dopmaps
	real(kind(1d0)), dimension(:,:), allocatable	::	psic
	! chi = default dopmap
	real(kind(1d0)), dimension(:), allocatable		::	chi

	real(kind(1d0)), dimension(:), allocatable		::	gs, fs
	real(kind(1d0)), dimension(:), allocatable		::	tphii, tphi0, tphase
	real(kind(1d0)), dimension(:), allocatable		::	tpsi, mavg, mamp
	real(kind(1d0)), dimension(:), allocatable		::	mpha, mpham, mphap
	real(kind(1d0)), dimension(:,:), allocatable	::	tpsic
	real(kind(1d0)), dimension(:,:), allocatable	::	mpix

	! ierr = return code (alfa_processed, fme_scheme)
	! 	ierr = 0: not converged
	! 	ierr = 1: not converged
	! 	ierr = 2: not monotonic
	! 	ierr = 3: not converged, not monotonic
	! 	ierr = 4: stuck at vanishing updates
	integer											::	ierr

!******************************************************************************

!******************************************************************************
contains
!******************************************************************************

!******************************************************************************


!******************************************************************************

!******************************************************************************
end module mdoptomog
!******************************************************************************

!******************************************************************************

#!/bin/bash
################################################################################
# remember: chmod 755 7-gnu.binarymodel.sh
################################################################################
# write gnuplot version to temporary file
gnuplot --version > gnuplotVersion
# parse version from file
read sDum sVer sDum sPatch < gnuplotVersion
# remove temporary file
rm gnuplotVersion
# validate version
v4=4
vpt4=4
vpt6=6
if (( ${sVer%%.*} != $v4 || ( ${sVer##*.} != $vpt4 && ${sVer##*.} != $vpt6 ) )) ; then
	echo " >:( $sVer is an invalid gnuplot version!"
	source $scpdir/shell/continue.sh 1
	exit
fi
################################################################################
# default plotting parameters
x0=0.0 # x-origin
y0=0.0 # y-origin
if (( ${sVer%%.*} == $v4 && ${sVer##*.} == $vpt4 )) ; then
	x0=0.0 # x-origin
	y0=0.525 # y-origin
fi
sc=3.5	# scale
rS=1.0	# radius of primary scale factor
cI=0	# centre of mass indicator (0 = system, 1 = primary)
eS=0	# exclude secondary (0 = no, 1 = yes)
dA=0	# display axes (0 = no, 1 = yes)
sS=1	# if sS = 1 skip user input
################################################################################
# set parent directory
prtdir=$(pwd)
# set code directory
cdedir=$prtdir/code
# set script directory
scpdir=$prtdir/scripts
# set sources directory
srcdir=$prtdir/sources
################################################################################
# user input
# get source folder name
result=1
while [ $result -eq 1 ]; do
	read -p "Source folder name (e.g., mcv, etc.)? "
	if [ ! -z "$REPLY" ]; then
		# call validatedir.sh to check if source folder exists
		source $scpdir/shell/validatedir.sh $srcdir $REPLY 1
		result=$?
	fi
done
# set source
src=$REPLY
# set source folder path
srcfldr=$srcdir/$src
################################################################################
# call validatedir.sh to check if binarymodel output folder exists
source $scpdir/shell/validatedir.sh $srcfldr/out/binarymodel/ gnu 1
if [ "$?" -eq 1 ]; then exit; fi
################################################################################
# get plotting terminal
declare -a terms=(["1"]=1 ["2"]=1 ["3"]=1 ["9"]=1)
result=1
while [ $result -eq 1 ]; do
	read -p "Plotting terminal (1 = ps, 2 = eps, 3 = png, 9 = wxt [screen])? "
	if [[ ${terms[$REPLY]} ]]; then
		result=0
	else
		echo " >:( Invalid terminal... try again!"
	fi
done
# set plotting terminal
trm=$REPLY
################################################################################
# go to gnu script folder...
cd $scpdir/gnu
# process model script
# set source path
srcpath=$srcfldr/in/
# set binarymodel source path
modpath=$srcfldr/out/binarymodel/gnu/
# execute gnuplot script
echo "executing 'binarymodel3d.plt' in GNUPlot..."
# plotting parameters
pp="terminal=$trm; scale=$sc; x0=$x0; y0=$y0; comInd=$cI; exSec=$eS; dAxes=$dA; "
# paths and file name
pf="modpath='$modpath'; srcpath='$srcpath'; file='binarymodel3d'; sVer=$sVer"
gnuplot -e "$pp$pf" binarymodel3d.plt
# display output for ps
if [ "$trm" == "1" ]; then
	read -p "Display output (y/n)? "
	if [[ "$REPLY" =~ ^(y|yes|Y|YES|Yes)$ ]]; then
		gnome-open $modpath/binarymodel3d.ps &
	fi
fi
################################################################################
# back to parent directory
cd $prtdir
################################################################################
# continue (exit)
source $scpdir/shell/continue.sh 1
################################################################################

#!/bin/bash
################################################################################
# remember: chmod u+x makedir.sh
################################################################################
# arguments: wrkdir dir backup
################################################################################
# set working directory
wrkdir=$1
# set directory to make
dir=$2
# set backup check indicator
backup=$3
################################################################################
# set makedir indicator to no as default
makedir="n"
# check if 'dir' output folder exists
if [ -d $wrkdir/$dir ]; then
	# 'dir' output folder does exist
	if [ $backup -eq 1 ]; then
		# check if 'dir' output folder is empty
		if [ ! "$(ls -A $wrkdir/$dir 2> /dev/null)" == "" ]; then
			# check if existing output files must be backed up
			read -p "'$dir' output folder not empty... backup folder (y/n)? "
			if [[ "$REPLY" =~ ^(y|yes|Y|YES|Yes)$ ]]; then
				# determine the number of the backup
#				nr=$(find . -name $wrkdir/$dir.\* | wc -l)
				nr=$(find . -wholename $wrkdir/$dir.\* | wc -l)
				# backup existing folder
				mv $wrkdir/$dir $wrkdir/$dir.$nr
				# set makedir indicator to yes
				makedir="y"
			else
				read -p "remove existing files (y/n)? "
				if [[ "$REPLY" =~ ^(y|yes|Y|YES|Yes)$ ]]; then
					rm $wrkdir/$dir/*
					echo "removed existing files from '$dir' output folder..."
				fi
			fi
		fi
	fi
else
	# set makedir indicator to yes
	makedir="y"
fi
# check if makedir indicator is yes
if [ "$makedir" == "y" ]; then
	# make 'dir' output folder
    mkdir $wrkdir/$dir
	echo "created new '$dir' output folder..."
fi
################################################################################

#!/bin/bash
################################################################################
# remember: chmod 755 4-idl.doptomog.pre.sh
################################################################################
# set parent directory
prtdir=$(pwd)
# set code directory
cdedir=$prtdir/code
# set script directory
scpdir=$prtdir/scripts
# set sources directory
srcdir=$prtdir/sources
################################################################################
# get source folder name
result=1
while [ $result -eq 1 ]; do
	read -p "Source folder name (e.g., mcv, etc.)? "
	if [ ! -z "$REPLY" ]; then
		# call validatedir.sh to check if source folder exists
		source $scpdir/shell/validatedir.sh $srcdir $REPLY 1
		result=$?
	fi
done
# set source
src=$REPLY
# set source folder path
srcfldr=$srcdir/$src
################################################################################
# call validatedir.sh to check if doptomog output folder exists
source $scpdir/shell/validatedir.sh $srcfldr/out doptomog 1
if [ "$?" -eq 1 ]; then exit; fi
################################################################################
# go to idl script folder...
cd $scpdir/idl
# process tomogram files
# set doptomog source path
sdir=$srcfldr/out/doptomog/
# loop for standard and inside-out projections
for ((i=0; i<=1; i++))
do
	if [ $i -eq 0 ]; then mth="standard"; fi
	if [ $i -eq 1 ]; then mth="inside-out"; fi
	read -p "Execute 'doptomog' pre IDL script for $src $mth projection (y/n)? "
	if [[ "$REPLY" =~ ^(y|yes|Y|YES|Yes)$ ]]; then
		# set doptomog source file
		inf="doptomog.$i.out"
		# execute idl script
		echo "executing 'doptomogplotpre.pro' in IDL for $src $mth projection..."
		cmd="sdir='$sdir', inf='$inf', suf='.$i'"
		idl -e "DopTomogPlotPre, $cmd"
		# display output
		read -p "Display output (y/n)? "
		if [[ "$REPLY" =~ ^(y|yes|Y|YES|Yes)$ ]]; then
			gnome-open $srcfldr/out/doptomog/doptomog.$i.ps &
		fi
	fi
done
################################################################################
# process flux modulation mapping files
# call validatedir.sh to check if fluxmodmap doptomog output folder exists
source $scpdir/shell/validatedir.sh $srcfldr/out/doptomog fluxmodmap 0
if [ "$?" -eq 0 ]; then
	# set fluxmodmap doptomog source path
	sdir=$srcfldr/out/doptomog/fluxmodmap/
	# loop for standard and inside-out projections
	for ((i=0; i<=1; i++))
	do
		if [ $i -eq 0 ]; then mth="standard"; fi
		if [ $i -eq 1 ]; then mth="inside-out"; fi
		read -p "Execute 'doptomog' pre IDL script for $src $mth projection for flux modulation mapping (y/n)? "
		if [[ "$REPLY" =~ ^(y|yes|Y|YES|Yes)$ ]]; then
			# set doptomog source file
			inf="fluxmodmap.$i.out"
			# execute idl script
			echo "executing 'doptomogplotpre.pro' in IDL for $src $mth projection..."
			cmd="sdir='$sdir', inf='$inf', suf='.$i'"
			idl -e "DopTomogPlotPre, $cmd"
			# display output
			read -p "Display output (y/n)? "
			if [[ "$REPLY" =~ ^(y|yes|Y|YES|Yes)$ ]]; then
				gnome-open $sdir/doptomog.$i.ps &
			fi
		fi
	done
fi
################################################################################
# process half-phase tomogram files
# call validatedir.sh to check if halfphases doptomog output folder exists
source $scpdir/shell/validatedir.sh $srcfldr/out/doptomog halfphases 0
if [ "$?" -eq 0 ]; then
	# set halfphases doptomog source path
	sdir=$srcfldr/out/doptomog/halfphases/
	# loop for standard and inside-out projections
	for ((i=0; i<=1; i++))
	do
		if [ $i -eq 0 ]; then mth="standard"; fi
		if [ $i -eq 1 ]; then mth="inside-out"; fi
		# get nr of halfphases files
		nr=$(head -n 1 $srcfldr/out/doptomog/halfphases/halfphases.$i.out)
		n="$[$nr]"
		read -p "Execute 'doptomog' pre IDL script for $src $mth projection for $n half-phases (y/n)? "
		if [[ "$REPLY" =~ ^(y|yes|Y|YES|Yes)$ ]]; then
			n="$[$n-1]"
			for ((k=0; k<=$n; k++))
			do
				# set doptomog source file
				inf="doptomog.$i.$k.out"
				# execute idl script
				echo "$k : executing 'doptomogplotpre.pro' in IDL for $src $mth projection..."
				cmd="sdir='$sdir', inf='$inf', suf='.$i.$k'"
				idl -e "DopTomogPlotPre, $cmd"
				# display output
				read -p "Display output (y/n)? "
				if [[ "$REPLY" =~ ^(y|yes|Y|YES|Yes)$ ]]; then
					gnome-open $sdir/doptomog.$i.$k.ps &
				fi
			done
		fi
	done
fi
################################################################################
# back to parent directory
cd $prtdir
################################################################################
# continue (exit)
source $scpdir/shell/continue.sh 1
################################################################################

#!/bin/bash
################################################################################
# remember: chmod 755 5-exec.pbinarymodel.sh
################################################################################
# set parent directory
prtdir=$(pwd)
# set code directory
cdedir=$prtdir/code
# set script directory
scpdir=$prtdir/scripts
# set sources directory
srcdir=$prtdir/sources
################################################################################
# first things first...
# go to code directory
cd $cdedir
# compile pbinarymodel (if necessary)
make pbinarymodel
################################################################################
# get source folder name
result=1
while [ $result -eq 1 ]; do
	read -p "Source folder name (e.g., mcv, etc.)? "
	if [ ! -z "$REPLY" ]; then
		# call validatedir.sh to check if source folder exists
		source $scpdir/shell/validatedir.sh $srcdir $REPLY 1
		result=$?
	fi
done
# set source
src=$REPLY
# set source folder path
srcfldr=$srcdir/$src
################################################################################
# output directory
# call makedir.sh to make binarymodel output folders if necessary
source $scpdir/shell/makedir.sh $srcfldr out 0
source $scpdir/shell/makedir.sh $srcfldr/out binarymodel 0
source $scpdir/shell/makedir.sh $srcfldr/out/binarymodel gnu 0
source $scpdir/shell/makedir.sh $srcfldr/out/binarymodel idl 0
################################################################################
# call validatefile.sh to check if 'binarymodel.in' exists in 'srcfldr'/in
source $scpdir/shell/validatefile.sh $srcfldr/in binarymodel.in 1
if [ "$?" -eq 1 ]; then exit; fi
################################################################################
# process binary model
# set input path
inpath=$srcfldr/in/
# loop for idl and gnu
for ((h=0; h<=1; h++))
do
	if [ $h -eq 0 ]; then ext="gnu"; fi
	if [ $h -eq 1 ]; then ext="idl"; fi
	# set output path
	outpath=$srcfldr/out/binarymodel/$ext/
	# execute binarymodel in 'codedir' folder
	echo "executing 'binarymodel ($ext)' for $src..."
	./pbinarymodel $h $inpath $outpath
done
################################################################################
# cleanup
# call removedir.sh to remove binarymodel output folders if necessary
source $scpdir/shell/removedir.sh $srcfldr/out/binarymodel/gnu
source $scpdir/shell/removedir.sh $srcfldr/out/binarymodel/idl
source $scpdir/shell/removedir.sh $srcfldr/out/binarymodel
################################################################################
# back to parent directory
cd $prtdir
################################################################################
# continue (exit)
source $scpdir/shell/continue.sh 1
################################################################################

#!/bin/bash
################################################################################
# remember: chmod 755 6-idl.doptomog.sh
################################################################################
# set parent directory
prtdir=$(pwd)
# set code directory
cdedir=$prtdir/code
# set script directory
scpdir=$prtdir/scripts
# set sources directory
srcdir=$prtdir/sources
################################################################################
# get source folder name
result=1
while [ $result -eq 1 ]; do
	read -p "Source folder name (e.g., mcv, etc.)? "
	if [ ! -z "$REPLY" ]; then
		# call validatedir.sh to check if source folder exists
		source $scpdir/shell/validatedir.sh $srcdir $REPLY 1
		result=$?
	fi
done
# set source
src=$REPLY
# set source folder path
srcfldr=$srcdir/$src
################################################################################
# output directory
# call validatedir.sh to check if doptomog output folder exists
source $scpdir/shell/validatedir.sh $srcfldr/out/ doptomog 1
if [ "$?" -eq 1 ]; then exit; fi
# call validatedir.sh to check if binarymodel output folder exists
source $scpdir/shell/validatedir.sh $srcfldr/out/binarymodel/ idl 1
if [ "$?" -eq 1 ]; then
	read -p "Produce tomograms without 2d velocity overlay (y/n)? "
	if [[ "$REPLY" =~ ^(y|yes|Y|YES|Yes)$ ]]; then
		ovr=0
	else
		echo "Execute '5-exec.pbinarymodel.sh' to calculate binary model and go again! Bye for now!"
		source $scpdir/shell/continue.sh 1
		exit
	fi
else
	ovr=1
fi
################################################################################
# go to idl script folder...
cd $scpdir/idl
# copy parameter file to idl script folder
cp $srcfldr/in/binarymodel.in .
# set binarymodel source path
mdir=$srcfldr/out/binarymodel/idl/
################################################################################
# process tomogram files
# set doptomog source path
sdir=$srcfldr/out/doptomog/
# loop for standard and inside-out projections
for ((i=0; i<=1; i++))
do
	if [ $i -eq 0 ]; then mth="standard"; fi
	if [ $i -eq 1 ]; then mth="inside-out"; fi
	read -p "Execute 'doptomog' IDL script for $src $mth projection (y/n)? "
	if [[ "$REPLY" =~ ^(y|yes|Y|YES|Yes)$ ]]; then
		# set doptomog source file
		inf='doptomog.'$i'.out'
		# execute idl script
		echo "executing 'doptomogplot.pro' in IDL for $src $mth projection..."
		cmd="sdir='$sdir', mdir='$mdir', inf='$inf', suf='.$i', ovr=$ovr"
		idl -e "DopTomogPlot, $cmd"
		# display output
		read -p "Display output (y/n)? "
		if [[ "$REPLY" =~ ^(y|yes|Y|YES|Yes)$ ]]; then
			if [ $ovr -eq 1 ]; then
				gnome-open $srcfldr/out/doptomog/dopmap.$i.vmod.ps &
			else
				gnome-open $srcfldr/out/doptomog/dopmap.$i.ps &
			fi
		fi
	fi
done
################################################################################
# process flux modulation mapping files
# call validatedir.sh to check if fluxmodmap doptomog output folder exists
source $scpdir/shell/validatedir.sh $srcfldr/out/doptomog fluxmodmap 0
if [ "$?" -eq 0 ]; then
	# set fluxmodmap doptomog source path
	sdir=$srcfldr/out/doptomog/fluxmodmap/
	# loop for standard and inside-out projections
	for ((i=0; i<=1; i++))
	do
		if [ $i -eq 0 ]; then mth="standard"; fi
		if [ $i -eq 1 ]; then mth="inside-out"; fi
		read -p "Execute 'doptomog' IDL script for $src $mth projection for flux modulation mapping (y/n)? "
		if [[ "$REPLY" =~ ^(y|yes|Y|YES|Yes)$ ]]; then
			# IDL script flags
			amf=0.1
			read -p "Amplitude filter (amf), i.e., display phase of maximum flux where amplitudes > amf * maximum amplitude (default = 0.1)? "
			if [ ! -z "$REPLY" ] && (( "$REPLY" >= "0" )); then
				amf=$REPLY
			fi
			echo "Amplitude filter (amf) used: "$amf
			# set doptomog source file
			inf="fluxmodmap.$i.out"
			# execute idl script
			echo "executing 'doptomogplot.pro' in IDL for $src $mth projection..."
			cmd="sdir='$sdir', mdir='$mdir', inf='$inf', suf='.$i', ovr=$ovr, amf=$amf"
			idl -e "DopTomogPlot, $cmd"
			# display output
			read -p "Display output (y/n)? "
			if [[ "$REPLY" =~ ^(y|yes|Y|YES|Yes)$ ]]; then
				if [ $ovr -eq 1 ]; then
					gnome-open $srcfldr/out/doptomog/fluxmodmap/dopmap.$i.vmod.ps &
					gnome-open $srcfldr/out/doptomog/fluxmodmap/moduamp.$i.vmod.ps &
					gnome-open $srcfldr/out/doptomog/fluxmodmap/moduphap.$i.vmod.ps &
				else
					gnome-open $srcfldr/out/doptomog/fluxmodmap/dopmap.$i.ps &
					gnome-open $srcfldr/out/doptomog/fluxmodmap/moduamp.$i.ps &
					gnome-open $srcfldr/out/doptomog/fluxmodmap/moduphap.$i.ps &
				fi
			fi
		fi
	done
fi
################################################################################
# process half-phase tomogram files
# call validatedir.sh to check if halfphases doptomog output folder exists
source $scpdir/shell/validatedir.sh $srcfldr/out/doptomog halfphases 0
if [ "$?" -eq 0 ]; then
	# set halfphases doptomog source path
	sdir=$srcfldr/out/doptomog/halfphases/
	# loop for standard and inside-out projections
	for ((i=0; i<=1; i++))
	do
		if [ $i -eq 0 ]; then mth="standard"; fi
		if [ $i -eq 1 ]; then mth="inside-out"; fi
		# get nr of halfphases files
		nr=$(head -n 1 $srcfldr/out/doptomog/halfphases/halfphases.$i.out)
		n="$[$nr]"
		read -p "Execute 'doptomog' IDL script for $src $mth projection for $n half-phases (y/n)? "
		if [[ "$REPLY" =~ ^(y|yes|Y|YES|Yes)$ ]]; then
			n="$[$n-1]"
			for ((k=0; k<=$n; k++))
			do
				# set doptomog source file
				inf="doptomog.$i.$k.out"
				# execute idl script
				echo "$k : executing 'doptomogplot.pro' in IDL for $src $mth projection..."
				cmd="sdir='$sdir', mdir='$mdir', inf='$inf', suf='.$i.$k', ovr=$ovr"
				idl -e "DopTomogPlot, $cmd"
				# display output
				read -p "$k : Display output (y/n)? "
				if [[ "$REPLY" =~ ^(y|yes|Y|YES|Yes)$ ]]; then
					if [ $ovr -eq 1 ]; then
						gnome-open $srcfldr/out/doptomog/halfphases/dopmap.$i.$k.vmod.ps &
					else
						gnome-open $srcfldr/out/doptomog/halfphases/dopmap.$i.$k.ps &
					fi
				fi
			done
		fi
	done
fi
################################################################################
# remove parameter file from idl script folder
rm binarymodel.in
################################################################################
# back to parent directory
cd $prtdir
################################################################################
# continue (exit)
source $scpdir/shell/continue.sh 1
################################################################################

#!/bin/bash
################################################################################
# remember: chmod 755 3_execute.pdoptomog.sh
################################################################################
# set parent directory
prtdir=$(pwd)
# set code directory
cdedir=$prtdir/code
# set script directory
scpdir=$prtdir/scripts
# set sources directory
srcdir=$prtdir/sources
################################################################################
# first things first...
# go to code directory
cd $cdedir
# compile pdoptomog (if necessary)
make pdoptomog
################################################################################
# get source folder name
result=1
while [ $result -eq 1 ]; do
	read -p "Source folder name (e.g., mcv, etc.)? "
	if [ ! -z "$REPLY" ]; then
		# call validatedir.sh to check if source folder exists
		source $scpdir/shell/validatedir.sh $srcdir $REPLY 1
		result=$?
	fi
done
# set source
src=$REPLY
# set source folder path
srcfldr=$srcdir/$src
################################################################################
# output directory
# call validatedir.sh to check if spectra output folder exists
source $scpdir/shell/validatedir.sh $srcfldr/out spectra 1
if [ "$?" -eq 1 ]; then exit; fi
# call makedir.sh to make doptomog output folder if necessary
source $scpdir/shell/makedir.sh $srcfldr/out doptomog 0
################################################################################
# call validatefile.sh to check if 'doptomog.in' exists in 'srcfldr'/in
source $scpdir/shell/validatefile.sh $srcfldr/in doptomog.in 1
if [ "$?" -eq 1 ]; then exit; fi
################################################################################
# process spectra for doppler tomography
# set doptomog source path
outfldr=$srcfldr/out/doptomog
# loop for standard and inside-out projections
for ((i=0; i<=1; i++))
do
	if [ $i -eq 0 ]; then mth="standard"; fi
	if [ $i -eq 1 ]; then mth="inside-out"; fi
	read -p "Execute pdoptomog for $src $mth projection (y/n)? "
	if [[ "$REPLY" =~ ^(y|yes|Y|YES|Yes)$ ]]; then
		# execute doptomog in 'codedir' folder
		echo "executing pdoptomog for $src $mth projection..."
		./pdoptomog $i $srcfldr/
		# check if half-phases where calculated
		source $scpdir/shell/validatefile.sh $outfldr halfphases.$i.out 0
		if [ "$?" -eq 0 ]; then
			# make halfphases folder (if necessary)
			source $scpdir/shell/makedir.sh $outfldr halfphases 0
			# move halfphases files to halfphases folder
			# get nr of halfphases files
			n=$(head -n 1 $outfldr/halfphases.$i.out)-1
			for ((k=0; k<=$n; k++))
			do
				# move halfphases file
				mv $outfldr/doptomog.$i.$k.out $outfldr/halfphases/doptomog.$i.$k.out
			done
			mv $outfldr/halfphases.$i.out $outfldr/halfphases/halfphases.$i.out
		fi
		# check if flux modulation mapping was done
		source $scpdir/shell/validatefile.sh $outfldr fluxmodmap.$i.out 0
		if [ "$?" -eq 0 ]; then
			# make fluxmodmap folder (if necessary)
			source $scpdir/shell/makedir.sh $outfldr fluxmodmap 0
			# move fluxmodmap file to fluxmodmap folder
			mv $outfldr/fluxmodmap.$i.out $outfldr/fluxmodmap/fluxmodmap.$i.out
		fi
	fi
done
################################################################################
# cleanup
# call removedir.sh to remove doptomog output folder if necessary
source $scpdir/shell/removedir.sh $srcfldr/out doptomog
################################################################################
# back to parent directory
cd $prtdir
################################################################################
# continue (exit)
source $scpdir/shell/continue.sh 1
################################################################################
